﻿
#include "stdafx.h"
#include <time.h>
#include <limits.h>

#include <stdexcept>

#include "../../Kernel/kernelincludes.h"
#include "../../Multilevel/Blif.h"
#include "../../Multilevel/Node.h"
#include "../../Multilevel/Signal.h"
#include "../../Multilevel/Network.h"

#include "Hradlo.h"
#include "RekonBunkaSeznam.h"
#include "RekonObj.h"
#include "GenerVstupu.h"
#include "Vstup.h"
#include "Gener.h"

Gener::Gener(){
}
bool Gener::gbitjejedna(bitvector b){
	for(unsigned int i=0; i<b.size();i++){
		if(b[i]==0){
			return false;
		}
	}
	return true;
}

bool Gener::gbitjenula(bitvector b){
	for(unsigned int i=0; i<b.size();i++){
		if(b[i]==1){
			return false;
		}
	}
	return true;
}



void Gener::vysledky(vector< vector< Hradlo*> > * uobv, Vstup * param){
	cout<<"Results:"<<endl;
	cout << "Inputs: " << param->pocetVstupu-param->latch <<" OK"<< endl;
    cout << "Outputs: " << param->pocetVystupu-param->latch <<" OK"<< endl;
	cout << "Level output:";
	for(unsigned  int i=0; i<param->urovneVystupu.size();i++){
		cout<<param->urovneVystupu[i]<<" ";
	}
	cout<<" OK"<<endl;
	cout<<"Latchs: "<<param->latch<<" OK"<<endl;
	if(param->latch>0){
		cout << "Level latch: ";
		for(unsigned  int i=0; i<param->urovneLatch.size();i++){
			cout<<param->urovneLatch[i]<<" ";
		}
		cout<<" OK"<<endl;
	}
    cout << "Levels: " << param->pocetUrovniObvodu <<" OK"<< endl;
    cout << "Max inputs node: " << param->maxPocetVstupuHradla <<" OK"<< endl;
	if(param->pocetHradel==-1){
		//neni urcen zakladni mod
		vector<pair<int,int> > sig;
		for(unsigned int i =0; i<uobv->at(uobv->size()-1).size();i++){
			sig.push_back(make_pair<int,int>(uobv->size()-1,i));
		}
		cout <<"Nodes: NaN -> "<<getPocetHradel(uobv,&sig)<<endl;

	}else{
		cout <<"Nodes: "<<param->pocetHradel<<" OK"<<endl;

	}
    cout << "Max lenght signals: " << param->hloubkaNavaznosti <<" OK"<< endl;
	if(param->maxVetveni!=-1){
	     cout<< "Max signal fanout: "<<param->maxVetveni<<" -> "<< getMaxVetveni(uobv)<<endl;
	}else{
		cout<< "Max signal fanout: NaN -> "<<getMaxVetveni(uobv)<<endl;
	}
	if(param->prumerVetveni!=-1){
	    cout<< "Average signal fanout: "<<param->prumerVetveni<<" -> "<< getPrumerVetveni(uobv)<<endl;
	}else{
		cout<< "Average signal fanout: NaN -> "<<getPrumerVetveni(uobv)<<endl;
	}


}
/*obvod musi byt uz pojmenovany*/
void Gener::prepocitatRiditelnost(vector< vector< Hradlo*> > * uobv){
	for(unsigned int i=1; i<uobv->size();i++){
		for(unsigned int j=0; j<uobv->at(i).size();j++){
			if(uobv->at(i).at(j)->getoname()!=""){
				uobv->at(i).at(j)->vypoctiRiditelnostCOP();
			}
		}
	}

}

void Gener::saveParam(Vstup * param, string soubor){
	ofstream stream(soubor.c_str(), ios::out);


	stream<<".model"<<endl;
	stream<<param->model<<endl;
	stream<<".levels"<<endl;
	stream<<param->pocetUrovniObvodu<<endl;
	stream<<".inputs"<<endl;
	stream<<param->pocetVstupu<<endl;
	stream<<".outputs"<<endl;
	stream<<param->pocetVystupu<<endl;
	stream<<".leveloutput"<<endl;
	for(unsigned int i=0; i<param->urovneVystupu.size();i++){
		stream<<param->urovneVystupu[i]<<" ";
	}
	stream<<endl;
	if(param->latch!=0){
		stream<<".latch"<<endl;
		stream<<param->latch<<endl;
		stream<<".levellatch"<<endl;
		for(unsigned int i=0; i<param->urovneLatch.size();i++){
			stream<<param->urovneLatch[i]<<" ";
		}
		stream<<endl;
	}
	stream<<".nodes"<<endl;
	stream<<param->pocetHradel<<endl;
	stream<<".maxinputsnode"<<endl;
	stream<<param->maxPocetVstupuHradla<<endl;
	stream<<".maxlenghtsignals"<<endl;
	stream<<param->hloubkaNavaznosti<<endl;
	stream<<".maxsignalfanout"<<endl;
	stream<<param->maxVetveni<<endl;
	stream<<".averagesignalfanout"<<endl;
	stream<<param->prumerVetveni<<endl;
	stream<<".inv"<<endl;//{INV, XOR, NXOR, AND, OR, NAND, NOR}
	stream<<param->cetnost[0]<<endl;
	stream<<".xor"<<endl;
	stream<<param->cetnost[1]<<endl;
	stream<<".nxor"<<endl;
	stream<<param->cetnost[2]<<endl;
	stream<<".and"<<endl;
	stream<<param->cetnost[3]<<endl;
	stream<<".or"<<endl;
	stream<<param->cetnost[4]<<endl;
	stream<<".nand"<<endl;
	stream<<param->cetnost[5]<<endl;
	stream<<".nor"<<endl;
	stream<<param->cetnost[6]<<endl;
}

void Gener::prepocitatPokryti(vector< vector< Hradlo*> > * uobv){
	bitvector b;
	Hradlo * h;
	for(unsigned int i=1; i<uobv->size();i++){
		for(unsigned int j=0; j<uobv->at(i).size();j++){
			if(uobv->at(i).at(j)->getoname()==""){continue;}

			h =uobv->at(i).at(j);
			b=h->getihradlo()->at(0)->getPokryti();
			for(unsigned int k=1;k<h->getihradlo()->size();k++){
				b=b|h->getihradlo()->at(k)->getPokryti();
			}
			h->setPokryti(b);
		}
	}
}
/*obvod musi byt pojmenovany, navazany a jen to co potrebuju*/
 void Gener::getMnozVetveni(vector< vector< Hradlo*> > * obv, vector< vector< Hradlo*> > * obvvetveni, bool sTMP){
	 obvvetveni->clear();
	 vector< Hradlo*>  a;
	 for(unsigned int i=0; i<obv->size()-1;i++){//bez vystupu
		
		for( unsigned int j=0; j<obv->at(i).size();j++){
			if(obv->at(i).at(j)->getoname()==""){continue;}// nepojmenovane hradlo nepatri do obvodu.
			if(obv->at(i).at(j)->getohradlo()==NULL){continue;}//vystup nekde uprostrostred... zastupny vystup nebo nepouzite hradlo
			if(sTMP==true&&obv->at(i).at(j)->tmp==-1){continue;}// vetveni, ktere se uz nema objevit v seznamu, neco jako skip
			while(obv->at(i).at(j)->getohradlo()->size()>=obvvetveni->size()){
				obvvetveni->push_back(a); //index je pocet vetveni
			}
			obvvetveni->at(obv->at(i).at(j)->getohradlo()->size()).push_back(obv->at(i).at(j));
		}

	}
 }
 
 bool Gener::riditelnostVystupuProjde(vector< vector< Hradlo*> > * obvN, double minRiditelnost, double maxRiditelnost){
	 prepocitatRiditelnost(obvN);
	 Hradlo *hr;
	 for(unsigned int t=0;t<obvN->at(obvN->size()-1).size();t++){
		 if(obvN->at(obvN->size()-1).at(t)->getLevel()==-1){
			 hr=obvN->at(obvN->size()-1).at(t)->getihradlo()->at(0);
		 }else{
			 hr=obvN->at(obvN->size()-1).at(t);
		 }
		 if (!(hr->getRiditelnostCOP() > minRiditelnost && hr->getRiditelnostCOP() < maxRiditelnost)) {
			return false;

		 }
	 }
	 return true;
 }

 bool Gener::pokrytiVystupuIsOne(vector< vector< Hradlo*> > * obvN){
	 prepocitatPokryti(obvN);
	 bitvector b;
	 Hradlo * hr;
	 b=obvN->at(obvN->size()-1).at(0)->getPokryti();
	 for(unsigned int t=1;t<obvN->at(obvN->size()-1).size();t++){
		 if(obvN->at(obvN->size()-1).at(t)->getLevel()==-1){
			hr=obvN->at(obvN->size()-1).at(t)->getihradlo()->at(0);
		 }else{
			 hr=obvN->at(obvN->size()-1).at(t);
		 }
		 b=b|hr->getPokryti();
	 }


	 return gbitjejedna(b);

 }
/*Vrati maximalni pocet pridanych urovni struktury, ktera se pouziva na yvetseni poctu vystupu*/
int Gener::getMaxPocetPridanychUrovniKvuliVystupum(int pocetUrovni, int hloubkaNavaznosti){
	int maxpocetpridanychurovnihradel=(pocetUrovni/hloubkaNavaznosti);
		if(pocetUrovni%hloubkaNavaznosti!=0){
			maxpocetpridanychurovnihradel++;
		}
		return maxpocetpridanychurovnihradel;

}
/*Vrati pocet hradel, ktere budu potrebovat na dokonceni urciteho poctu vystupu, pri hledani obvodu
s urcitzm poctem hradel*/
int Gener::getPocetHradelNavicNaVystupy(Vstup * param){

	int celkem=0;
	int plus=1;
	for(unsigned int i=1; i<param->urovnedohromady.size();i++){
		if(param->urovnedohromady[i]==0) continue;
		if(param->urovnedohromady[i]==param->urovnedohromady[i-1]){
			plus++;
		}else{
			plus=1;
		}
		celkem+=min(plus,getMaxPocetPridanychUrovniKvuliVystupum(param->urovnedohromady[i],param->hloubkaNavaznosti));
	}
	return celkem;

}

int Gener::nastaveniSirkyObvoduTABheur(Vstup * param){
		ifstream in;
		string err;
		double ax=0;
		double ay=25;//zjisteno z grafu
		double bx=100;//podle toho na jake sirce se meri
		double by=0; //ztabulky

		param->hloubkaNavaznosti=min(param->hloubkaNavaznosti,param->pocetUrovniObvodu);

		in.open("heur.dat");
		if (!in.is_open()){
			
			throw logic_error("File heur.dat not found. I use the internal system.");
		}
		int hledanaNavaznost, hledanyLevel, hledanypocetvstupu;
		int	   pint;
		vector<int> navaznost, levels, vstupy;
		in>>pint;
		while(pint!=0){
			vstupy.push_back(pint);
			in>>pint;
		}
		in>>pint;
		while(pint!=0){
			navaznost.push_back(pint);
			in>>pint;
		}
		in>>pint;
		while(pint!=0){
			levels.push_back(pint);
			in>>pint;
		}
		

		hledanypocetvstupu=vstupy[vstupy.size()-1]; //nastavim na max
		for(unsigned int i=0; i<vstupy.size();i++){ //delam to kvuli neyavisloti na souboru dat, nemuzu predpokladat nic.
			if(vstupy[i]==param->maxPocetVstupuHradla){
				hledanypocetvstupu=vstupy[i];
				break;
			}

		}


		hledanaNavaznost=navaznost[navaznost.size()-1];//nastavim na max
		for(unsigned int i=0; i<navaznost.size();i++){ //navaznost mensi
			if(param->hloubkaNavaznosti==navaznost[i]){
				hledanaNavaznost=navaznost[i];
				break;
			}else{
				if(param->hloubkaNavaznosti<navaznost[i]){
					hledanaNavaznost=navaznost[i-1];
					break;
				}
			}

		}



		int rozdil=0;
		double h1,h2;
		h1=0;
		h2=0;
		hledanyLevel=levels[levels.size()-1]; //prednastaveni

		if(levels[0]>param->pocetUrovniObvodu){
			hledanyLevel=levels[0];
		}else{
			for(unsigned int i=0; i<levels.size();i++){//level bude vetsi
				if(param->pocetUrovniObvodu==levels[i]){
					hledanyLevel=levels[i];
					break;
				}else{
					if(param->pocetUrovniObvodu<levels[i]){

							rozdil=levels[i]-levels[i-1];
							hledanyLevel=levels[i];
							break;
					}
				}

			}
		}

		if(levels[levels.size()-1]<param->pocetUrovniObvodu){//uroven neni v souboru, aproximuji jen levels

			 int hledanylevel2= levels[levels.size()-2];
			
			double hy1=0;
			double hy2=0; //dva body pro aproximaxi
			for(unsigned int v=0; v<vstupy.size();v++){
				for(unsigned int i=0; i<levels.size();i++){
					for(unsigned int j=0; j<navaznost.size();j++){
						if(navaznost[j]>levels[i]){//navaznost je max level
								break;
						}
					
						in>>by;
						if(hledanypocetvstupu==vstupy[v]&&hledanaNavaznost==navaznost[j]){
							if(levels[i]==hledanyLevel){
								hy1=by;
							}
							if(levels[i]==hledanylevel2){
								hy2=by;

							}
						}
					}
				}
			}
			//mam body budu aproximovat x=level y je hledana hodnota
			double ak=(hy2-hy1)/(hledanylevel2-hledanyLevel);
			double aq = hy1-ak*hledanyLevel;
			by=ak*param->pocetUrovniObvodu+aq;

			
		}else{
			bool konec=false;
				for(unsigned int v=0; v<vstupy.size();v++){
					for(unsigned int i=0; i<levels.size();i++){
						for(unsigned int j=0; j<navaznost.size();j++){
							if(navaznost[j]>levels[i]){//navaznost je max level
									break;
							}
							in>>by;
							
							if(hledanypocetvstupu==vstupy[v]){
								if(rozdil!=0){
									if((levels[i]==hledanyLevel-rozdil)&&navaznost[j]==hledanaNavaznost){
									h1=by;
									}
								}

								if(levels[i]==hledanyLevel&&navaznost[j]==hledanaNavaznost){
									konec=true;
									break;
								}
							}
						}
						if(konec)break;
					}
					if(konec)break;
				}
				if(rozdil!=0){
					double rozdilby=by-h1;
					rozdilby=rozdilby/rozdil;
					while(hledanyLevel!=param->pocetUrovniObvodu){
						by=by-rozdilby;
						hledanyLevel--;
					}
				}
		}
		
		in.close();
		double k,q;
		k=(by-ay)/(bx-ax);
		q=ay-(k*ax);
		double sirkad;
		int hradel=param->pocetHradel-1- getPocetHradelNavicNaVystupy(param) ;
		sirkad =(hradel-q)/k;
		return static_cast<int> (sirkad);
}

int Gener::nastaveniSirkyObvodu(Vstup * param) {
	double sirka;
	int s;
		if(param->maxSirkaObvodu!=-1){
		return param->maxSirkaObvodu;
	}
	try{
		s=nastaveniSirkyObvoduTABheur(param);
		return max(20,min(180,s));//min 20 a max 180

	 } catch (exception e) {
		 cout<<e.what()<<endl;

	}



    if (param->pocetUrovniObvodu <= 4) {
        return 50;
    }
    if (param->pocetUrovniObvodu <= 6) {
		if ((param->hloubkaNavaznosti < 4) && ((param->pocetHradel-1-getPocetHradelNavicNaVystupy(param) )< 20)) {
            return 25;
        } else {
            return 50;
        }
    }
    if (param->pocetUrovniObvodu <= 8) {
        if ((param->hloubkaNavaznosti < 4) && ((param->pocetHradel-1-getPocetHradelNavicNaVystupy(param) ) < 30)) {
            return 50;
        } else {
            return 100;
        }
    }
    double q = 12.26667 * param->pocetUrovniObvodu - 70.6668;
    double k = 0.2611 * param->pocetUrovniObvodu - 2.4444;
    double koefq, koefk;

    if (param->hloubkaNavaznosti > (param->pocetUrovniObvodu / 2)) {
        koefq = 1;
        koefk = 1;
    } else {
        if (param->hloubkaNavaznosti > (param->pocetUrovniObvodu / 4)) {
            koefq = 1.1;
            koefk = 1.2;
        } else {
            if (param->hloubkaNavaznosti > (param->pocetUrovniObvodu / 8)) {
                koefq = 1.2;
                koefk = 1.8;
            } else {
                koefq = 2;
                koefk = 2.5;
            }
        }
    }
    k = k*koefk;
    q = q*koefq;
	sirka = (param->pocetHradel-1-getPocetHradelNavicNaVystupy(param) - q) / k;
    sirka = sirka + 30;
    int intsirka = static_cast<int> (sirka);
    intsirka = max(intsirka, 30);
    intsirka = min(intsirka, 100);
    return intsirka;
}
//vlozi vsechny hradla splnujici parametry
void Gener::rekDosazitelnaMnozina( Hradlo * h, int aktualniUroven, int hloubkaNavaznosti,  vector<Hradlo*> * dosazitelnaMnozina){
	if(h->getLevel()<(max(aktualniUroven-hloubkaNavaznosti,0))){
		return;
	}
	if(h->tmpdosazitelnaMnozina==33){
		return;
	}

	if(h->getLevel()>=(aktualniUroven-hloubkaNavaznosti)&&h->getLevel()<aktualniUroven){
		dosazitelnaMnozina->push_back(h);
		h->tmpdosazitelnaMnozina=33;
	}
	if(h->getLevel()==0){
		return;
	}
	for(unsigned int i=0; i<h->getihradlo()->size();i++){
		rekDosazitelnaMnozina(h->getihradlo()->at(i),aktualniUroven,hloubkaNavaznosti, dosazitelnaMnozina);
	}


}
/*Vrati mnozinu hradel, ktera se je dosazitelna z urcite urovne*/
void Gener::getDosazitelnaMnozina(vector< vector< Hradlo*> > * obv, Hradlo * h , vector<Hradlo*> * dosazitelnaMnozina, int aktualniUroven, int hloubkaNavaznosti){
	dosazitelnaMnozina->clear();
	//smazu temp
	 for(unsigned int i=0; i<obv->size();i++){
		 for(unsigned int j=0; j<obv->at(i).size();j++){
			 obv->at(i).at(j)->tmpdosazitelnaMnozina=0;
		   }
	  }


	rekDosazitelnaMnozina(h,aktualniUroven,hloubkaNavaznosti,dosazitelnaMnozina);

	return;
}


Node * Gener::generAND(bool neg, vector<string> * inames, string oname) {
    PLA * pl;
    Term * t;
    Node * nod;
    string str = "";
    pl = new PLA(inames->size(), 1);
    pl->setINames((*inames));
    pl->setOName(0, oname);
    if (neg) {
        pl->setType("r");
    } else {
        pl->setType("f");
    }

    t = new Term(inames->size(), 1);
    for (unsigned int i = 0; i < inames->size(); i++) {
        str = str + "1";
    }
    t->setCube(str);
    if (neg) {
        t->setOM("0");
    } else {
        t->setOM("1");
    }

    pl->AppendTerm((*t));
    nod = new Node((*pl));

    return nod;
}

Node * Gener::generOR(bool neg, vector<string> * inames, string oname) {
    PLA * pl;
    Term * t;
    Node * nod;
    string str = "";
    pl = new PLA(inames->size(), 1);
    pl->setINames((*inames));
    pl->setOName(0, oname);
    if (neg) {
        pl->setType("f");
    } else {
        pl->setType("r");
    }
    t = new Term(inames->size(), 1);
    for (unsigned int i = 0; i < inames->size(); i++) {
        str = str + "0";
    }
    t->setCube(str);
    if (neg) {
        t->setOM("1");
    } else {
        t->setOM("0");
    }
    pl->AppendTerm((*t));
    nod = new Node((*pl));

    return nod;
}
//dva vstupy
Node * Gener::generXOR(bool neg, vector<string> * inames, string oname) {
    PLA * pl;
    Term * t;
    Node * nod;
    string str = "";
    pl = new PLA(2, 1);
    pl->setINames((*inames));
    pl->setOName(0, oname);
    if (neg) {
        pl->setType("r");
    } else {
        pl->setType("f");
    }
    t = new Term(2, 1);
    str = "01";
    t->setCube(str);
    if (neg) {
        t->setOM("0");
    } else {
        t->setOM("1");
    }
    pl->AppendTerm((*t));

    t = new Term(2, 1);
    str = "10";
    t->setCube(str);
    if (neg) {
        t->setOM("0");
    } else {
        t->setOM("1");
    }
    pl->AppendTerm((*t));
    nod = new Node((*pl));
    return nod;
}

Node * Gener::generINV(string iname, string oname) {
    PLA * pl;
    Term * t;
    Node * nod;
    pl = new PLA(1, 1);
    pl->setIName(0, iname);
    pl->setOName(0, oname);
    pl->setType("f");
    t = new Term(1, 1);
    t->setCube("0");
    t->setOM("1");
    pl->AppendTerm((*t));
    nod = new Node((*pl));
    return nod;
}

string Gener::bitvectortostr(bitvector b) {
    string s = "";
    for (unsigned int i = 0; i < b.size(); i++) {
        if (b[i])s = s + "1";
        else s = s + "0";
    }
    return s;
}

string Gener::inttostr(int const in, int const velikost) {
    string s = "";
    int cislo = in;
    int p;
    int exp = 1;
    for (int i = 0; i < velikost - 1; i++) {
        exp = exp * 10;
    }
    for (int i = 0; i < velikost; i++) {
        p = cislo / exp;
		if(char(p + 48)==':' ||char(p + 48)==';'){
			cout<<"chyba"<<endl;
		}
        s = s + char(p + 48);
        cislo = cislo - (p * exp);
        exp = exp / 10;
    }
	
    return s;
}

string Gener::pojmenujHradlo(int * pocet, Hradlo * h, const int velikost, const int velikostl) {
    int p = (*pocet);
    if (h->getLevel() == 0) {
        return "i" + inttostr(h->getiport(), velikost);
    } else {
        return "h" + inttostr(p, velikost) + "l" + inttostr(h->getLevel(), velikostl);
    }

}

//nastavi oname, ohradlo, inames
void Gener::pojmenovaniSignalu(Hradlo *h, int * pocet, int velikost, int velikost2) {
    Hradlo * ih;
    if (h->getLevel() == 0) {//VSTUPY
        return;
    }
    for (int i = 0; i < h->geticount(); i++) {
        ih = h->getihradlo()->at(i);
        //navazu
        ih->pushoHradlo(h);
        if (ih->getoname().size() != 0) {// hradlo je pojmenovano
            continue;
        }
        //pojmenuji
        ih->setOName(pojmenujHradlo(pocet, ih, velikost, velikost2));
		if(ih->getLevel()!=0){// vstup nema pocet hradel vstup je vzdy ixx kde x je cislo vstupu, hradla se musejí odlisit
			(*pocet)++;
		}
        pojmenovaniSignalu(ih, pocet, velikost, velikost2);

    }

    return;
}

void Gener::pojmenovaniObvodu( int pocethradel, int levels, vector< vector< Hradlo*> > * uobv) {
    int pocet = 0;
    int velikost = 0;
    int velikost2 = 0;
    int exp = 1;
    while ((pocethradel / (exp)) != 0) {
        velikost++; // velikost nazvu hradel
        exp = exp * 10;
    }
    exp = 1;
    while ((uobv->size() / (exp)) != 0) {
        velikost2++; //velikost levelu
        exp = exp * 10;
    }


    for (unsigned int i = 0; i < uobv->at(levels).size(); i++) { //pro vsechny vystupy
        //pojmenuji
        if (uobv->at(levels).at(i)->getLevel() == -1) {//zastupne hradlo
			
			uobv->at(levels).at(i)->getihradlo()->at(0)->setOName(pojmenujHradlo(&pocet, uobv->at(levels).at(i)->getihradlo()->at(0), velikost, velikost2));
			if(uobv->at(levels).at(i)->getihradlo()->at(0)->getLevel()!=0){//vstupy naji vlastni pojmenovani
			    pocet++; //zvysim pocet
			}
			pojmenovaniSignalu(uobv->at(levels).at(i)->getihradlo()->at(0), &pocet, velikost, velikost2); //zanorim
        }else{
			uobv->at(levels).at(i)->setOName(pojmenujHradlo(&pocet, uobv->at(levels).at(i), velikost, velikost2));
			pocet++; //zvysim pocet
			pojmenovaniSignalu(uobv->at(levels).at(i), &pocet, velikost, velikost2); //zanorim
		}
    }



}

void Gener::ulozOBV(vector< vector< Hradlo*> > * obv, Vstup * param){
	Hradlo * hr;
	string nazev=param->model+".blif";
	ofstream stream(nazev.c_str(), ios::out);
	if (!stream.is_open()) throw IOException("Cannot open file: " + nazev);
	stream<<".model "<<param->model<<endl;
	stream<<".inputs";
	for(unsigned  int i=0; i<obv->at(0).size()-param->latch;i++){
		stream<<" "<<obv->at(0).at(i)->getoname();
	}
	stream<<endl;


	stream<<".outputs";
	for(unsigned int i=0; i<obv->at(obv->size()-1).size();i++){

		if(obv->at(obv->size()-1).at(i)->getLevel()==-1){//zastupne hradlo
			hr=obv->at(obv->size()-1).at(i)->getihradlo()->at(0);
		}else{
			hr=obv->at(obv->size()-1).at(i);
		}
		if(hr->getoname().c_str()[1]=='o'){
			stream<<" "<<hr->getoname();

		}
	}
	stream<<endl;
	//latch


	int uk=0;
	for(unsigned int i=0; i<obv->at(obv->size()-1).size();i++){

		if(obv->at(obv->size()-1).at(i)->getLevel()==-1){//zastupne hradlo
			hr=obv->at(obv->size()-1).at(i)->getihradlo()->at(0);
		}else{
			hr=obv->at(obv->size()-1).at(i);
		}
		if(hr->getoname().c_str()[1]=='p'){
			stream<<".latch";
			stream<<" "<<hr->getoname();
			stream<<" "<<obv->at(0).at(param->pocetVstupu-param->latch+uk)->getoname()<< " 0"<<endl;
			uk++;

		}
	}
	//tady budou latch
	Node * n=NULL;
	bool neg = false;
    for (unsigned int i = 1; i < obv->size(); i++) {
        for (unsigned int j = 0; j < obv->at(i).size(); j++) {
            if (obv->at(i).at(j)->getoname() == "" || obv->at(i).at(j)->getLevel() == -1) {
                continue;
            }//nepojmenovane, zastupne -> nefunkcni


            neg = false;
            switch (obv->at(i).at(j)->getType()) {//vypocitam pozorovatelnostCOP
                case INV:
                    n=generINV(obv->at(i).at(j)->getinames()->at(0), obv->at(i).at(j)->getoname());
                    break;
                case NXOR:
                    neg = true;
                case XOR:
                     n=generXOR(neg, obv->at(i).at(j)->getinames(), obv->at(i).at(j)->getoname());
                    break;
                case NAND:
                    neg = true;
                case AND:
                    n=generAND(neg, obv->at(i).at(j)->getinames(), obv->at(i).at(j)->getoname());
                    break;
                case NOR:
                    neg = true;
                case OR:
                    n=generOR(neg, obv->at(i).at(j)->getinames(), obv->at(i).at(j)->getoname());
                    break;

                default:
                    cout << "Chyba vypis obv" << endl;
                    break;
            }
			stream<<".names";
			for(unsigned  int x=0;x<n->getData()->getINames().size();x++){
				stream<<" "<<n->getData()->getINames()[x];
			}
			stream<<" "<<n->getData()->getOName(0)<<endl;

			
			for(list<Term>::iterator x = n->getData()->getData()->begin(); x!=n->getData()->getData()->end();x++){
				stream<<x->getCube()<<" "<<x->getOM()<<endl;
			}
			delete n;
        }
    }
	stream<<".end"<<endl;
	stream.close();
	cout<<"File "<<nazev<<" save."<<endl;

}

Network * Gener::obvToNetwork(vector< vector< Hradlo*> > * obv) {
    Network * net = new Network();
    //pripojim vstupy
    for (unsigned int i = 0; i < obv->at(0).size(); i++) {
        net->AddInput(obv->at(0).at(i)->getoname());
    }

    //pripojim vystupy
    for (unsigned int i = 0; i < obv->at(obv->size() - 1).size(); i++) {
        if (obv->at(obv->size() - 1).at(i)->getLevel() == -1) {
            net->AddOutput(obv->at(obv->size() - 1).at(i)->getihradlo()->at(0)->getoname());
        } else {
            net->AddOutput(obv->at(obv->size() - 1).at(i)->getoname());
        }
    }
    bool neg = false;
    for (unsigned int i = 1; i < obv->size(); i++) {
        for (unsigned int j = 0; j < obv->at(i).size(); j++) {
            if (obv->at(i).at(j)->getoname() == "" || obv->at(i).at(j)->getLevel() == -1) {
                continue;
            }//nepojmenovane, zastupne -> nefunkcni


            neg = false;
            switch (obv->at(i).at(j)->getType()) {//vypocitam pozorovatelnostCOP
                case INV:
                    net->AddNode((*generINV(obv->at(i).at(j)->getinames()->at(0), obv->at(i).at(j)->getoname())));
                    break;
                case NXOR:
                    neg = true;
                case XOR:
                    net->AddNode((*generXOR(neg, obv->at(i).at(j)->getinames(), obv->at(i).at(j)->getoname())));
                    break;
                case NAND:
                    neg = true;
                case AND:
                    net->AddNode((*generAND(neg, obv->at(i).at(j)->getinames(), obv->at(i).at(j)->getoname())));
                    break;
                case NOR:
                    neg = true;
                case OR:
                    net->AddNode((*generOR(neg, obv->at(i).at(j)->getinames(), obv->at(i).at(j)->getoname())));
                    break;

                default:
                    cout << "Chyba obvtonet" << endl;
                    break;
            }
        }
    }
   net->GenerateSignals();
    return net;


}

void Gener::vypocetCOPPozorovatelnosti(vector< vector< Hradlo*> > * obv) {
    for (int i = obv->size() - 1; i >= 0; i--) {
        for (unsigned int j = 0; j < obv->at(i).size(); j++) {
				     obv->at(i).at(j)->vypoctiPozorovatelnostCOP();
        }
    }
}

string Gener::typetostr(HType t) {
    string s;
    switch (t) {
        case INV:
            s = "INV";
            break;
        case NXOR:
            s = "NXOR";
            break;
        case XOR:
            s = "XOR";
            break;
        case NAND:
            s = "NAND";
            break;
        case AND:
            s = "AND";
            break;
        case NOR:
            s = "NOR";
            break;
        case OR:
            s = "OR";
            break;
		default:
			s="Err";
			cout<<"s"<<(int) t<<endl;
			break;
    }
    return s;

}

void Gener::obvinfo(vector< vector< Hradlo*> > * obv, Vstup * param, bool nactenySoubor) {
	Hradlo * hr;
	int uk=0;
	int sumaRek=0;
	//nazev modulu muze obsahovat /
	string newmodel="" ;
	for(unsigned int i=0; i<param->model.size();i++){
		if(param->model.c_str()[i]=='/'){
			newmodel=newmodel+"_";
		}else{
			newmodel=newmodel+param->model.c_str()[i];
		}
	}

	param->model=newmodel;
	string nazevs;
		nazevs=param->model;

	ofstream stream((nazevs + ".log").c_str(), ios::out);
    if (!stream.is_open()){
		throw IOException("Can not open file: " + (param->model+ ".log"));
	}
    stream << "Model :" << param->model << endl;

	
	
	if(nactenySoubor==false){
		stream << "Inputs: " << param->pocetVstupu-param->latch << endl;
		stream << "C(x) - controllability, O(x) - observability" << endl;
		for (unsigned int i = 0; i < obv->at(0).size()-param->latch; i++) {

			stream << obv->at(0).at(i)->getoname() << " C(x): " << obv->at(0).at(i)->getRiditelnostCOP() << "\t\tO(x): " << obv->at(0).at(i)->getPozorovatelnostCOPVystupu() << endl;

		}
    stream << endl;
	}else{
		stream << "Inputs: " << param->pocetVstupu << endl;
	}
	uk=0;
	if(nactenySoubor==false){
			stream << "Outputs: " << obv->at(obv->size() - 1).size()-param->latch << endl;
	
			for (unsigned int i = 0; i < obv->at(obv->size() - 1).size(); i++) {

				if (obv->at(obv->size() - 1).at(i)->getLevel() == -1) {//zastupny vystup
					hr=obv->at(obv->size() - 1).at(i)->getihradlo()->at(0);
				} else {
					hr= obv->at(obv->size() - 1).at(i);
				}

				if(hr->getoname().c_str()[1]=='o'){
					stream <<hr->getoname() <<"\t"<< " C(x): " << hr->getRiditelnostCOP() << "\t\tO(x): " << hr->getPozorovatelnostCOPVystupu() <<"\t\tL: "<<param->urovnedohromady[i]<< endl;
					uk++;
				}

			}
	}else{
		stream << "Outputs: " << param->pocetVystupu<< endl;
		for (unsigned int i = 0; i < param->urovneVystupu.size(); i++) {
			stream<<"L: "<<param->urovneVystupu[i]<<endl;
		}

	}
	stream <<"Latchs: "<<param->latch<<endl;
	if(nactenySoubor==false){
		uk=0;
		for (unsigned int i = 0; i < obv->at(obv->size() - 1).size(); i++) {

			if (obv->at(obv->size() - 1).at(i)->getLevel() == -1) {//zastupny vystup
				hr=obv->at(obv->size() - 1).at(i)->getihradlo()->at(0);
			} else {
				hr= obv->at(obv->size() - 1).at(i);
			}

			if(hr->getoname().c_str()[1]=='p'){
				stream <<"Latch "<<hr->getoname() << " "<<obv->at(0).at(param->pocetVstupu-param->latch+uk)->getoname()<<" L: "<< param->urovnedohromady[i]<<endl;
				uk++;
			}

		}
	}else{
		for (unsigned int i = 0; i < param->urovneLatch.size(); i++) {
			stream<<"L: "<<param->urovneLatch[i]<<endl;
		}
	}
		stream << "Levels: " <<param->pocetUrovniObvodu << endl;
		param->hloubkaNavaznosti=getNavaznost(obv);
		stream <<"Max lenght signals: "<<param->hloubkaNavaznosti<<endl;
	if(param->pocetHradel==-1){
		//neni urcen yakladni mod
		vector<pair<int,int> > sig;
		for(unsigned int i =0; i<obv->at(obv->size()-1).size();i++){
			sig.push_back(make_pair<int,int>(obv->size()-1,i));
		}
		param->pocetHradel=getPocetHradel(obv,&sig);


	}
	stream <<"Nodes: "<<param->pocetHradel<<endl;
	
	vector<int> pocethradel;
	pocethradel=getCetnostHradel(obv);
	stream<<"INV "<<pocethradel[0]<<endl;
	stream<<"XOR "<<pocethradel[1]<<endl;
	stream<<"NXOR "<<pocethradel[2]<<endl;
	stream<<"AND "<<pocethradel[3]<<endl;
	stream<<"OR "<<pocethradel[4]<<endl;
	stream<<"NAND "<<pocethradel[5]<<endl;
	stream<<"NOR "<<pocethradel[6]<<endl;
	stream<<"Average signal fanout: "<<getPrumerVetveni(obv)<<endl;
	stream<<"Max signal fanout: "<<getMaxVetveni(obv)<<endl;
	if(param->rekonvergence.size()!=0){
		stream<<endl;

		stream<<"Reconvegrence signals : velikost/pocet"<<endl;
		for(unsigned int i=2; i<param->rekonvergence.size();i++){
			stream<<i<<"\t\t";

		}
		stream<<endl;
		for(unsigned int i=2; i<param->rekonvergence.size();i++){
			sumaRek=sumaRek+param->rekonvergence[i].size();
			stream<<param->rekonvergence[i].size()<<"\t\t";

		}
	
		
		 stream << endl;
	}

    stream << endl;

	if(nactenySoubor==false){
		for (unsigned int i = 1; i < obv->size(); i++) {
			for (unsigned int j = 0; j < obv->at(i).size(); j++) {
				if (obv->at(i).at(j)->getoname() == "" || obv->at(i).at(j)->getLevel() == -1) {
					continue;
				}

				stream << "Node " << obv->at(i).at(j)->getoname() << "   " << typetostr(obv->at(i).at(j)->getType()) << endl;
				stream << "Level "<<obv->at(i).at(j)->getLevel()<<endl;
				stream << "\tC(x) input:" << endl;
				for (unsigned int k = 0; k < obv->at(i).at(j)->getihradlo()->size(); k++) {
					stream << "\t\t" << obv->at(i).at(j)->getihradlo()->at(k)->getoname() << "  " << obv->at(i).at(j)->getihradlo()->at(k)->getRiditelnostCOP() << endl;
				}
				stream << "\tC(x) output:" << endl;
				stream << "\t\t" << obv->at(i).at(j)->getoname() << "  " << obv->at(i).at(j)->getRiditelnostCOP() << endl;
				stream << "\tO(x) input:" << endl;
				for (unsigned int k = 0; k < obv->at(i).at(j)->getihradlo()->size(); k++) {
					stream << "\t\t" << obv->at(i).at(j)->getihradlo()->at(k)->getoname() << "  " << obv->at(i).at(j)->getPozorovatelnostCOPVstupu(k) << endl;
				}
				stream << "\tO(x) output:" << endl;
				stream << "\t\t" << obv->at(i).at(j)->getoname() << "  " << obv->at(i).at(j)->getPozorovatelnostCOPVystupu() << endl;
				stream << endl;
				stream << endl;
			}
		}
	}
    stream.close();
/*
	ofstream stream2("vysledky.txt", ios::app);
	stream2<<param->model<<";";
	if(nactenySoubor){
		stream2<<param->soubor<<";"<<param->pocetVstupu<<";"<<param->pocetVystupu;
	}else{
		param->soubor=param->model+".blif";
		stream2<<param->soubor<<";"<<param->pocetVstupu-param->latch<<";"<<param->pocetVystupu-param->latch;
	}
	for(unsigned int j=0; j<param->urovneVystupu.size();j++){
		if(j==0){stream2<<"(";}
		stream2<<param->urovneVystupu[j];
		if(j==param->urovneVystupu.size()-1){stream2<<")";}else{stream2<<"#";}
	}
	stream2<<";"<<param->latch;
	for(unsigned int j=0; j<param->urovneLatch.size();j++){
		if(j==0){stream2<<"(";}
		stream2<<param->urovneLatch[j];
		if(j==param->urovneLatch.size()-1){stream2<<")";}else{stream2<<"#";}
	}
	stream2<<";"<<param->pocetUrovniObvodu;
	stream2<<";"<<param->pocetHradel;
	stream2<<";"<<param->hloubkaNavaznosti;
	stream2<<";"<<param->maxPocetVstupuHradla;
	stream2<<";"<<getMaxVetveni(obv);
	stream2<<";"<<getPrumerVetveni(obv);
	stream2<<";"<<pocethradel[0];
	stream2<<";"<<pocethradel[1];
	stream2<<";"<<pocethradel[2];
	stream2<<";"<<pocethradel[3];
	stream2<<";"<<pocethradel[4];
	stream2<<";"<<pocethradel[5];
	stream2<<";"<<pocethradel[6];
	stream2<<";"<<sumaRek;
	for(unsigned int i=2; i<param->rekonvergence.size();i++){
		stream2<<";"<<param->rekonvergence[i].size();
	}

	stream2<<endl;
	stream2.close();
	*/
}

void Gener::rekgetPocetHradel(Hradlo * hr, int * pocet, int unikat) {
    if (hr->tmp == unikat || hr->getLevel() == 0) {
        return;
    }
    (*pocet)++;
    hr->tmp = unikat;
    for (unsigned int i = 0; i < hr->getihradlo()->size(); i++) {
        rekgetPocetHradel(hr->getihradlo()->at(i), pocet, unikat);
    }

}

int Gener::getPocetHradel(vector< vector< Hradlo*> > * obv, vector<pair<int, int> > * signaly) {
    //misto mazani temp, si vygeneruji nahodne cislo a zkontroluji
    //, zda v urovni 1 neexistuje hradlo se stejnym cislem
    bool b = true;
    int unikat;
    int pocet = 0;

    while (b) {
        b = false;
        unikat = rand();
		//vzdy se musi pouzit minimalne prvni uroven, proto staci projit tohle
        for (unsigned  int i = 0; i < obv->at(1).size(); i++) {
            if (obv->at(1).at(i)->tmp == unikat) {
                b = true;
                break;
            }
        }
    }
    //mame unikatni cislo...
    //nastavime si hradla na tmp a potom projdeme zbytek obvodu...
    for (unsigned int i = 0; i < signaly->size(); i++) {
        rekgetPocetHradel(obv->at(signaly->at(i).first).at(signaly->at(i).second), &pocet, unikat);
    }

    return pocet;
}

void Gener::snizVetveni(vector< vector< Hradlo*> > * obvN, Vstup * param, double minRiditelnost, double maxRiditelnost){
	vector< vector< Hradlo*> > obvvetveni; //prvni souradnice pocet vetveni a v nich hradla/signaly
	 Hradlo * hr;
	 Hradlo * hrnext=NULL;
	 Hradlo* hrnew=NULL;
	 Hradlo * vet;


	 vector <Hradlo *> ohradlokopie;
	 bool konec;
	 vector <Hradlo *> * ohradlo;
	 int maxvetveniAktual;
	 double prumervetveniAktual;
	 if(param->maxVetveni!=-1){
		 maxvetveniAktual=param->maxVetveni;
	 }else{
		 maxvetveniAktual= INT_MAX;
	 }
	 if(param->prumerVetveni>0){
		 prumervetveniAktual=param->prumerVetveni;
	 }else{
		 prumervetveniAktual=100000000;
	 }

	 //smazu tmp
		for(unsigned int i=0; i<obvN->size();i++){
			for(unsigned int j=0; j<obvN->at(i).size();j++){
				obvN->at(i).at(j)->tmp=0;
			  }
		 }



	 getMnozVetveni(obvN,&obvvetveni,false);
	
	 while((int)(obvvetveni.size()-1)>maxvetveniAktual){
			
			hr=obvvetveni[obvvetveni.size()-1][0];
			ohradlo=hr->getohradlo();
			ohradlokopie.clear();
			ohradlokopie.assign(ohradlo->begin(),ohradlo->end());
			 //snizim signal o jedno vetveni
			 do{
				 konec=false;
				 if(ohradlokopie.size()==0){//vyzkou3el jsem vsechny vetveni, zadna nesla prepojit
					 //projdu to znova vetveni a zkusim nejake zrusit
					 //nesmim ale zrusit takovy vstup, ktery je jediny u uroven min
					 for(unsigned int k=0; k<hr->getohradlo()->size();k++){
						 hrnext=hr->getohradlo()->at(k);
						 if(hrnext->geticount()>2){
							 //podminka aby se nezmenil pocet urovni obvodu
							 if((hrnext->getLevel()!=hr->getLevel()+1)||
								 ((hrnext->getLevel()==hr->getLevel()+1)&&(hrnext->existujeJinyVstupZMinuleUrovneNez(hr)))){
								 hr->eraseohradlo(hrnext);
								 hrnext->eraseihradlo(hrnext->getiindex(hr));
								  if(riditelnostVystupuProjde(obvN,minRiditelnost,maxRiditelnost)&&pokrytiVystupuIsOne(obvN)){
										konec=true;
										break;
								  }else{
									  hr->pushoHradlo(hrnext);
									  hrnext->pushiHradlo(hr);
								  }
						     }
						 }
					 }
					if(!konec){
						hr->tmp=-1;
					}
					break;
				 }
				 

					 //vetev je vzdy 0, protoze kdyz s ni manipuluju dostane se na konec
				  if(konec){break;}
				 hrnext= ohradlokopie[0];
				
				 //najdu kam to zapojim
				 
				 for(unsigned int i =1;i<hr->getohradlo()->size()-2;i++){//pujdu od signalu s nejmensim vetvenim do signalu s vetvenim o dva mensi
					 for(unsigned  int j=0;j<obvvetveni[i].size();j++){
						 vet = obvvetveni[i][j];
						 if(obvvetveni[i][j]->getLevel()>=hrnext->getLevel()){continue;} //nezapojit do stejne urovne nobo dopredu
						 if(hrnext->getLevel()-obvvetveni[i][j]->getLevel()>param->hloubkaNavaznosti){continue;} //ale ne zase moc dozadu
						 if(hrnext->jeDuplicitniVstup(obvvetveni[i][j])){continue;} //duplicita vstupu
						 if((hrnext->getLevel()==hr->getLevel()+1)&&(!hrnext->existujeJinyVstupZMinuleUrovneNez(hr))&&(vet->getLevel()!=hr->getLevel())){					
							 continue;
						 }//zniceni posloupnosti urovni
						 hrnew=obvvetveni[i][j];
						
						 hr->eraseohradlo(hrnext);
						 hrnext->eraseihradlo(hr);
						 hrnext->pushiHradlo(hrnew);
						 hrnew->pushoHradlo(hrnext);
						 if(riditelnostVystupuProjde(obvN,minRiditelnost,maxRiditelnost)){
						
							 konec=true;
							 break;
						 }else{
							 //vratit zpet
							 hrnew->eraseohradlo(hrnext);
							 hrnext->eraseihradlo(hrnew);
							 hr->pushoHradlo(hrnext);
							 hrnext->pushiHradlo(hr);
						 }
						 /***/

					 }
					 if(konec){break;}
				 }
				 ohradlokopie.erase(ohradlokopie.begin());
			 }while(!konec);





			 getMnozVetveni(obvN,&obvvetveni,true);
	 }


	 //ted snizim prumer to lze jen smazanim vetvi
	 vector<Hradlo *> vhradelnasnizeni;
	 if(param->prumerVetveni!=-1){
		 for(unsigned int i=1; i<obvN->size();i++){
			for(unsigned int j=0; j<obvN->at(i).size();j++){
				obvN->at(i).at(j)->tmp=0;
				if(obvN->at(i).at(j)->getLevel()==-1){continue;}
				if(obvN->at(i).at(j)->getohradlo()==NULL){continue;}
				if(obvN->at(i).at(j)->geticount()>2){
					vhradelnasnizeni.push_back(obvN->at(i).at(j));
				}
			}
		}
	 }
	 int uk;
	 Hradlo * hrback;
	 while((param->prumerVetveni!=-1)&&(getPrumerVetveni(obvN)>param->prumerVetveni)){

		 if(vhradelnasnizeni.size()==0){
			 break;
		 }
		//man vector hradel, kde jsou jen ty hradla s v2tsim poctem vstupu, muzu je tedy odstranit
		 uk=rand()%vhradelnasnizeni.size();
		 hr=vhradelnasnizeni[uk];
		 	//projdu to znova vetveni a zkusim nejake zrusit
		 int index =0;
		while(hr->getihradlo()->size()>2){
			if(index>=(int)hr->getihradlo()->size()){break;}
			hrback=hr->getihradlo()->at(index);
			if(hrback->getohradlo()->size()<=1){index++; continue;}
			if((hrback->getLevel()==hr->getLevel()-1)&&(!hr->existujeJinyVstupZMinuleUrovneNez(hrback))){ index++; continue;}
			
				hr->eraseihradlo(hrback);
				hrback->eraseohradlo(hr);
				if(riditelnostVystupuProjde(obvN,minRiditelnost,maxRiditelnost)&&pokrytiVystupuIsOne(obvN)){
					break;
				}else{
					hr->pushiHradlo(hrback);
					hrback->pushoHradlo(hr);
					break;
				}
			
			
		}
		vhradelnasnizeni.erase(vhradelnasnizeni.begin()+uk);
		if(vhradelnasnizeni.size()==0){
			break;
		}

	  }

	 


 }


 vector<int> Gener::getCetnostHradel(vector< vector< Hradlo*> > * obvN){
	 vector<int> a;
	 for(int i=0; i<HTYPESIZE;i++){
		 a.push_back(0);
	 }
	  for(unsigned i=1;i<obvN->size();i++){
		   for(unsigned j=0;j<obvN->at(i).size();j++){
			  if(obvN->at(i).at(j)->getLevel()==-1){
				   continue; //zastupne hradlo
			   }
			  a[(int)obvN->at(i).at(j)->getType()]++;
		   }
	  }

	  return a;
 }


  int Gener::getMaxVstupHradla(vector< vector< Hradlo*> > * obvN){
	  int maximum=0;
	  for(unsigned i=1;i<obvN->size();i++){
		   for(unsigned j=0;j<obvN->at(i).size();j++){
			   if(obvN->at(i).at(j)->getLevel()==-1){
				   continue; //zastupne hradlo
			   }
			   maximum=max(maximum,obvN->at(i).at(j)->geticount());
		   }
      }
	  return maximum;
  }
  double Gener::getPrumerVetveni( vector< vector< Hradlo*> > * obvN ){
	 vector< vector< Hradlo*> > obvvetveni;
	 int suma=0;
	 int pocet=0;
	 getMnozVetveni(obvN,&obvvetveni,false);
	 for(unsigned int i=1; i<obvvetveni.size(); i++){
		 suma =suma+ i*obvvetveni[i].size();
		 pocet=pocet+obvvetveni[i].size();
	 }
	 //ještě je nutné zapocítat výstupní signály. Pokud je zde zástupní hradlo, je již jeho větvení za
	 //počítáno, takže projdu poslední uroven a napočítám počet hradel, 
	 //zde jsou jak vystupy tak i zastupna hradla
	 for(unsigned int i=0; i<obvN->at(obvN->size()-1).size(); i++){
			 
			 if(obvN->at(obvN->size()-1).at(i)->getLevel()==-1){//zastupne hradlo
				 if(obvN->at(obvN->size()-1).at(i)->getihradlo()->at(0)->getohradlo()==NULL){//bez dalsiho vetveni
					 suma++;
					 pocet++;
				 }else{//s dalsim vetvenim
					 suma++;
				 }
			 }else{
				 suma++;
					 pocet++;
			 }

	  }
	 double prumer=suma/((double)pocet);
	 return prumer;

 }

 int Gener::getMaxVetveni( vector< vector< Hradlo*> > * obvN ){
	 vector< vector< Hradlo*> > obvvetveni;
	 getMnozVetveni(obvN,&obvvetveni,false);
	 return max((int)obvvetveni.size()-1,(int)0);

 }

  int Gener::getNavaznost(vector< vector< Hradlo*> > * obvN ){
	  int navaznost=0;
	  Hradlo *ih;
	  int refuroven=20000000; //vstupy mohou byt na 5 urovni, ale tady budou na 0, musim min ze vsech nastupcu hradla
	for(unsigned int i=1; i<obvN->size();i++){
		for(unsigned int j=0; j<obvN->at(i).size();j++){
			if(obvN->at(i).at(j)->getLevel()<0){continue;}
			for(unsigned int k=0; k<obvN->at(i).at(j)->getihradlo()->size();k++){
				refuroven=20000000; 
				ih=obvN->at(i).at(j)->getihradlo()->at(k);
				//prijdu vystupy vstupu
				if(ih->getLevel()==0){
					for(unsigned int x=0; x<ih->getohradlo()->size();x++){
						refuroven=min(refuroven,ih->getohradlo()->at(x)->getLevel());
					}
				}else{
					refuroven=-1000; 
				}
				int pomoc=obvN->at(i).at(j)->getLevel()-(refuroven-1);
				int pomoc2=obvN->at(i).at(j)->getLevel()-obvN->at(i).at(j)->getihradlo()->at(k)->getLevel();
				navaznost=max(navaznost,min(pomoc,pomoc2) );
			}
		}
	}
	return navaznost;

 }



void Gener::getRekonvergence(vector< vector< Hradlo*> > * obvN,Vstup * param){
	list<RekonObj *>  rekonvergence;
	list<RekonObj *>  rekonvergence2;
	vector <RekonObj *> a;
	a.clear();
	int pocet=0;
	for(unsigned int i=0; i<obvN->size();i++){//od nuly musi se vztvorit linie v bunkach
		for(unsigned int j=0; j<obvN->at(i).size();j++){
			if(obvN->at(i).at(j)->getLevel()==-1){//zastupne hradlo
				continue;
			}
			obvN->at(i).at(j)->vypoctiRekonvergenci(obvN->at(0).size(),param->pocetUrovniObvodu);
			obvN->at(i).at(j)->getRokonvergenceVector(&param->rekonvergence);

		}
		cout<<".";
	}
	cout<<endl;
	cout<<"Size >> Count"<<endl;
	pocet=0;
	for(unsigned int i=2; i<param->rekonvergence.size();i++){
		cout<<i<<" >> "<< param->rekonvergence[i].size()<<endl;
		pocet=pocet+param->rekonvergence[i].size();
	}
	cout<<"Number of reconverging: "<<pocet<<endl;

}

Vstup Gener::blifinfo(Blif * b, string soubor){
	vector< vector< Hradlo*> > obv ;
	map<string, Hradlo*> mapaHradel;
	map<string, Hradlo*> mapaHradel2; //na ty co maji stanoveny level
	map<string, Hradlo*>::iterator itmap;
	list<SoPLA> * soplalist;
	vector< Hradlo*> a;
	Hradlo *h ;
	a.clear();
	vector<Hradlo *> mojevystupy;
	
	//vstupy
	for(unsigned int i=0; i<b->inputs();i++){
		h= new Hradlo(i);
		h->setOName(b->getIName(i));
		mapaHradel.insert(pair<string,Hradlo *>(h->getoname(),h));
		mapaHradel2.insert(pair<string,Hradlo *>(h->getoname(),h));//stanoveny level
	}
	soplalist = b->getData();
	HType typ;
	int zastoupeniHradel[HTYPESIZE];
	for(int i=0; i<HTYPESIZE;i++){
		zastoupeniHradel[i]=0;
	}
	int pocethradel=0;
	int pocetBuff=0;
	int pocetDDF=0;
	int pocetConst=0;
		//udelam hradla a ukazatele zatim ulozim do map
	for(list<SoPLA>::iterator it=soplalist->begin(); it!=soplalist->end();it++){
		if((*it).getGateName()=="one"||(*it).getGateName()=="zero"){//constanta jako ->vstupn9 signal
			h= new Hradlo(mapaHradel2.size());//tam jsou jen zatim vstupy a const a dff
			h->setOName((*it).getName());
			mapaHradel.insert(pair<string,Hradlo *>(h->getoname(),h));
			h->tmp=20;
			mapaHradel2.insert(pair<string,Hradlo *>(h->getoname(),h));
			pocetConst++;
			continue;

		}
		if((*it).getGateName()=="buf"){//buffer ignoruji, ale musim ho ulozit do mapy, jen yesiluje signal
			//takze dve jmena ukazuji na to same hradlo
			//buffer muze byt vystupni smazat buff a dat zastune hradlo
			
			pocetBuff++;
			mapaHradel.insert(pair<string,Hradlo *>((*it).getName(),mapaHradel.find((*it).getIName(0))->second));
			continue;
		}
		if((*it).isDFF()){//mame tu latch
			pocetDDF++;
			//dam ho jako vstup.
			h= new Hradlo(mapaHradel2.size());//tam jsou jen zatim vstupy a const a dff
			h->setOName((*it).getName());
			h->tmp=20;
			mapaHradel.insert(pair<string,Hradlo *>(h->getoname(),h));
			mapaHradel2.insert(pair<string,Hradlo *>(h->getoname(),h));
			continue;
		}


		//typedef enum HType  {INV, XOR, NXOR, AND, OR, NAND, NOR} HType;
		pocethradel++;
		if((*it).getGateName()=="inv"){
			typ=INV;
			zastoupeniHradel[0]++;
		}else{
			if((*it).getGateName()=="xor"){
				typ=XOR;
				zastoupeniHradel[1]++;
			}else{
				if((*it).getGateName()=="nxor"){
					zastoupeniHradel[2]++;
					typ=NXOR;
				}else{
					if((*it).getGateName()=="and"){
						zastoupeniHradel[3]++;
						typ=AND;
					}else{
						if((*it).getGateName()=="or"){
							zastoupeniHradel[4]++;
							typ=OR;
						}else{
							if((*it).getGateName()=="nand"){
								zastoupeniHradel[5]++;
								typ=NAND;
							}else{
								if((*it).getGateName()=="nor"){
									zastoupeniHradel[6]++;
									typ=NOR;
								}else{
									cout<<"Unknown node. "<<(*it).getGateName()<<endl;
									string err="Error bad mapping ABC.";
									throw logic_error(err.c_str());

								}
							}
						}
					}
				}
			}
		}

			h = new Hradlo();
			h->setOName((*it).getName());//jednovystupova 
			h->setType(typ);
			mapaHradel.insert(pair<string,Hradlo *>(h->getoname(),h));

	}


	
	//udelam si mnozinu vystupu kom obv
	for(unsigned int i=0; i<b->getONames().size();i++){
		mojevystupy.push_back(mapaHradel.find(b->getOName(i))->second);
	}


	for(list<SoPLA>::iterator it=soplalist->begin(); it!=soplalist->end();it++){// navazu ihradla
		
			h= mapaHradel.find((*it).getName())->second;
			if(h->tmp==20){ //dff a const jsou jako vstupy ale tady by to nikdo nepoznal vstupy 
				if((*it).getGateName()=="buf"){
					mojevystupy.push_back(mapaHradel.find((*it).getName())->second);
					continue;
				}
				if((*it).isDFF()){//tady bude jeden vystup
					mojevystupy.push_back(mapaHradel.find((*it).getIName(0))->second);

				}
				continue;
			}
			if((*it).getGateName()=="buf"){// nic nenastavuju, protoze vstup i vystup buff maji odkaz v mape hradel na jedno misto. duplicita.
				continue;
			}
		for(unsigned int i =0; i<(*it).inputs();i++){
			h->pushiHradlo(mapaHradel.find((*it).getIName(i))->second);
			mapaHradel.find((*it).getIName(i))->second->pushoHradlo(h);
		}
	}
	

	//nastavim levels.
	bool uloz=true;
	int level=-20;
	int maxlevel=0;

	while(mapaHradel2.size()!=soplalist->size()+b->inputs()-pocetBuff){
		for(list<SoPLA>::iterator it=soplalist->begin(); it!=soplalist->end();it++){
			if((*it).isDFF()||(*it).getGateName()=="one"||(*it).getGateName()=="zero"||(*it).getGateName()=="buf"){
				//ty uz jsou ulozeny jako vstupy na urovni 0;
				continue;
			}
			itmap=mapaHradel.find((*it).getName());
			if(itmap!=mapaHradel.end()){
				h= itmap->second;
				uloz=true;
				level=-202;
				for(int i=0; i<h->geticount();i++){
					itmap= mapaHradel2.find(h->getihradlo()->at(i)->getoname());
					if(itmap==mapaHradel2.end()){
						uloz=false;
					}else{
						level=max(level,itmap->second->getLevel());
					}
				}
				if(uloz){
					h->setLevel(level+1);
					maxlevel=max(level+1,maxlevel);
					mapaHradel2.insert(pair<string,Hradlo *>(h->getoname(),h));
					mapaHradel.erase(h->getoname());
				}
			}

	
		}
		
	}

	//tadz ok
	//roztahnu OBV
	for(int i =0; i<=maxlevel;i++){
		obv.push_back(a);
	}


		for(map<string, Hradlo*>::iterator it=mapaHradel2.begin(); it!=mapaHradel2.end();it++){
			obv[(*it).second->getLevel()].push_back((*it).second);
		}

	//jeste vytahnu zastupna hradla
		for(unsigned int i =0; i<mojevystupy.size();i++){// dat zastupna hradla
			if(mojevystupy[i]->getLevel()!=(int)obv.size()-1){
				obv[obv.size()-1].push_back(new Hradlo(  mojevystupy[i]  ));
			}
		}
	//mam obv zjistim parametry
		Vstup  param;
		param.soubor=soubor;
		param.latch=pocetDDF;
		param.pocetVstupu= b->inputs();
		param.pocetVystupu=b->outputs();
		param.pocetUrovniObvodu=maxlevel;
		param.maxVetveni=getMaxVetveni(&obv);
		param.prumerVetveni=getPrumerVetveni(&obv);
		param.model=b->GetModel();
		param.hloubkaNavaznosti=getNavaznost(&obv);
		param.maxPocetVstupuHradla=getMaxVstupHradla(&obv);
		param.pocetHradel=pocethradel;


		//param->cetnost=zastoupeniHradel;
		for(int i=0; i<HTYPESIZE;i++){
			param.cetnost[i]=zastoupeniHradel[i];
		}

		//budu yjistovat premiove parametry, potrebuju mit zase kompletni mapu hradel.
		for(map<string, Hradlo*>::iterator it=mapaHradel.begin(); it!=mapaHradel.end();it++){
			mapaHradel.insert(pair<string,Hradlo *>(it->first,it->second));
		}
		//kolik urovni je mezi vstupy a vystupy
		vector<int> diffout;
		map<string,Hradlo *>::iterator it2;
		string pomoc;
		for(unsigned int i= 0; i<b->getONames().size();i++){
			it2=mapaHradel2.find(b->getOName(i));
			if(it2==mapaHradel2.end()){
				//nenasel se. je tam buffer musim najit jeho vstup
					for(list<SoPLA>::iterator it=soplalist->begin(); it!=soplalist->end();it++){
						if((*it).getGateName()=="buf"&&(*it).getName()==b->getOName(i)){
							pomoc=(*it).getIName(0);
							break;
						}
					}
					it2=mapaHradel2.find(pomoc);
					h=it2->second;

			}else{
			    h=it2->second;
			}
			
			diffout.push_back(h->getLevel());
		}
		//kolik urovni je mizi vstupem a v7stupem latch
		vector<int> difflatch;
		
		for(list<SoPLA>::iterator it=soplalist->begin(); it!=soplalist->end();it++){
			if((*it).isDFF()){
				h=mapaHradel2.find(it->getName())->second;
				int minuroven=20000000;
				int maxuroven=0;
				if(h->getohradlo()==NULL){// nema zadne nasledovniky je to vstup na vystup. vstup muze byt vystup z latche pres buf na vystup
					//difflatch.push_back(0);
					minuroven=1;//je to ta nasledujedujici
					maxuroven=1;
				}else{
					for(unsigned int i=0; i<h->getohradlo()->size();i++){
						minuroven=min(minuroven, h->getohradlo()->at(i)->getLevel());
						maxuroven=max(maxuroven,h->getohradlo()->at(i)->getLevel());
					} 
				}
					//podlo toho jak je latch yapojen
					itmap=mapaHradel2.find(it->getIName(0));
					if(itmap==mapaHradel2.end()){//neni v prvni mnozine...
						itmap=mapaHradel.find(it->getIName(0));// je v druhe. asi bufff
					}
					if(itmap->second->getLevel()==0){
						difflatch.push_back(0);
					}else{
						cout<<(maxuroven)-itmap->second->getLevel()<<endl;
						cout<<itmap->second->getLevel()-(minuroven-1)<<endl;
						difflatch.push_back(max((maxuroven)-itmap->second->getLevel(),itmap->second->getLevel()-(minuroven-1)));
					}
				
				

			}
		}
		cout<<"----------"<<endl;
		cout<<"Model: "<<param.model<<endl;
		cout<<"Inputs: "<<param.pocetVstupu<<endl;
		cout<<"Outputs: "<<param.pocetVystupu<<endl;
		cout<<"Levels: ";
		for(unsigned int i=0; i<diffout.size();i++){
			cout<<" "<<diffout[i];
		}
		cout<<endl;
		cout<<"Levels: "<<param.pocetUrovniObvodu<<endl;
		cout<<"Max lenght signals: "<<param.hloubkaNavaznosti<<endl;
		cout<<"Max inputs node: "<<param.maxPocetVstupuHradla<<endl;
		cout<<"Nodes: "<<param.pocetHradel<<endl;
		cout<<"Latchs: "<<param.latch<<endl;
		
		for(unsigned int i=0; i<difflatch.size();i++){
			if(i==0){
				cout<<"Levels: ";
			}
			cout<<" "<<difflatch[i];
		}
		param.urovneLatch=difflatch;
		param.urovneVystupu=diffout;
		cout<<endl;
		cout<<"Max signal fanout: "<<param.maxVetveni<<endl;
		cout<<"Average signal fanout: "<<param.prumerVetveni<<endl;
		cout<<"Reconvergence";
		getRekonvergence(&obv,&param);
		try{
		        obvinfo(&obv,&param,true);
				} catch (exception e) {
		 cout<<e.what()<<endl;

	}


	return param;
}

  vector<int> Gener::getUrovneHradelNaJedenVystup(int cislovystupu, Vstup * param){
	  int pocethradel=0;
	  vector<int> v;
	int plus=1;
	if(param->urovnedohromady[cislovystupu]==0){
		return v;//vystupu z nulovou urovni. jedna se o protazeny vstup na vystup
	}
	for(unsigned int i=1; i<param->urovnedohromady.size();i++){
		if(param->urovnedohromady[i]==param->urovnedohromady[i-1]){
			plus++;
		}else{
			plus=1;
		}
		if((int)i==cislovystupu){
			pocethradel= min(plus,getMaxPocetPridanychUrovniKvuliVystupum(param->urovnedohromady[i],param->hloubkaNavaznosti));
			break;
		}
	
	}
	for(int i=0; i<pocethradel;i++){
		if(pocethradel!=1){
			if(i+1==getMaxPocetPridanychUrovniKvuliVystupum(param->urovnedohromady[cislovystupu],param->hloubkaNavaznosti)){
				v.insert(v.begin(),param->hloubkaNavaznosti);
				break;
			}
		}
		v.insert(v.begin(),param->urovnedohromady[cislovystupu]-i*param->hloubkaNavaznosti);

	}
	


	return v;

 }

void Gener::generovani(Vstup * param) {
	
    int levels = param->pocetUrovniObvodu;
    
    srand((unsigned int) time(NULL));
    Hradlo * hr;
    Hradlo * ihr;
    bitvector bitv, bitvNULL, bitvpom;

    HType typHradla;
    int tmp;
    int level = 0;
    int vstupyHradla;
    double minRiditelnost = 0.10;
    double maxRiditelnost = 0.90;

    vector < pair<int, int > > *ukazvstupvector;

    int zastoupeniHradel[HTYPESIZE];
    bitv.resize(param->pocetVstupu);
    bitvNULL.resize(param->pocetVstupu);
    for (int i = 0; i < param->pocetVstupu; i++) {
        bitvNULL.setbit(i, false);
    }
    for (int i = 0; i < HTYPESIZE; i++) {
        zastoupeniHradel[i] = 0;
    }

    //pole cetnosti
    vector<int> hradlaCetnost;
    for (int i = 0; i < HTYPESIZE; i++) {
        for (int j = 0; j < param->cetnost[i]; j++) {
            hradlaCetnost.push_back(i);
        }
    }

    bitvector bitlevelpokriti;
    bitlevelpokriti.resize(param->pocetVstupu);


    bool hradloPrijato = true;
    int pocetpripojeninavstup = 0;
    int typHradlaint = -1;
    GenerVstupu * genvst;
    int pocetHradelNaUrovni;
    //nastaveni poctu hrdel na urovni
    int maxPojistka = param->pocetVstupu * levels * 2;
    int jesteVystupu = 0;
   
    int minNalezenoHradel = 1000000000;
    int maxNalezenoHradel = -1;
	pocetHradelNaUrovni = max(max(param->pocetVstupu, param->pocetUrovniObvodu), param->pocetVystupu);
    //-----------------up pocet hradel---------------------
    if ((param->pocetHradel != -1) && (param->pocetUrovniObvodu != -1)) {
        levels--; //posledni uroven si budu muset dotvorit sam....
		cout << "Heuristics..." << endl;
        pocetHradelNaUrovni = nastaveniSirkyObvodu(param);

        
       
    } 
	 maxPojistka = param->pocetVstupu * levels*pocetHradelNaUrovni*10; //no a pojistka... .
	 cout << "Set widht: " << pocetHradelNaUrovni << endl;
    //-------------------------------------------------------
	 cout << "Generate";

    vector< vector< Hradlo*> > obv;
    vector<pair<int, int> > s;
    pair<int, int> p1, p2;
    level = 0; //navazu vstupy iports
    vector<Hradlo*> a;
    obv.push_back(a);
    for (int i = 0; i < param->pocetVstupu; i++) {
        bitv = bitv&bitvNULL;
        hr = new Hradlo(i);
        bitv.setbit(i, true); //nastavim pokryti
        hr->setPokryti(bitv);
        obv[0].push_back(hr);

    }

    cout << ".";
    for (level = 1; level < levels + 1; level++) {//nulty level je pro vstupy

        genvst = new GenerVstupu(&obv, level, param->hloubkaNavaznosti);
        pocetpripojeninavstup = 0;
        obv.push_back(a);
        int pojistka = 0;
        bitlevelpokriti = bitlevelpokriti&bitvNULL;
        //-----------------up----------------------------------
        if (param->pocetHradel == -1) {//-
            if (level == levels) pocetHradelNaUrovni = param->pocetVystupu;
        }


        //-------------------------------------------------------

        for (int i = 0; i < pocetHradelNaUrovni; i++) { //vytvorim hradla na prvni urovni

            pojistka++;
            if (pojistka > maxPojistka) {
                cout << "Error nodes tautology. L:" << level << endl;
                for (unsigned int i = 0; i < obv.size(); i++) {
                    for (unsigned int j = 0; j < obv[i].size(); j++) {
                        delete obv[i][j];
                    }
                }
                return;
            }

            typHradlaint = hradlaCetnost[rand() % hradlaCetnost.size()];
            typHradla = static_cast<HType> (typHradlaint); //vygeneruji typ hradla

			if(param->pocetVstupu==1&&level==1){ //kdyz je jen jeden vstup, tak prvni urove+n musi byt inv
				typHradla=INV;
				vstupyHradla=1;
			}else{

				switch (typHradla) { // vygeneruji pocet vstupu
					case INV:
						vstupyHradla = 1;
						break;
					case XOR:
					case NXOR:
						vstupyHradla = 2;
						break;
					default:
						if (level == 1) {
							vstupyHradla = ((rand() % (param->pocetVstupu - 1) % (param->maxPocetVstupuHradla - 1)) + 2); //aby nebylo vice vstupu hradla nez portu
						} else {
							vstupyHradla = ((rand() % (param->maxPocetVstupuHradla - 1)) + 2);
						}
						
						break;
				}


			}


            hr = new Hradlo(level, typHradla); //vytvorim hradlo
            // vymazu bitv.
            bitv = bitv&bitvNULL;

            //pripojim mu vstupy a navazu ukazatele vstupu.
            ukazvstupvector = genvst->getSignal(vstupyHradla, hradloPrijato);


            for (unsigned int j = 0; j < ukazvstupvector->size(); j++) {
                ihr = obv[ukazvstupvector->at(j).first][ukazvstupvector->at(j).second];
                hr->pushiHradlo(ihr);
                bitv = bitv | ihr->getPokryti();
            }
            delete ukazvstupvector;
            hr->vypoctiRiditelnostCOP();
            hr->setPokryti(bitv);

       
            //zbavit se tautologie

            if (hr->getRiditelnostCOP() > minRiditelnost && hr->getRiditelnostCOP() < maxRiditelnost) {
				if (level == levels && !  gbitjejedna(hr->getPokryti()) && param->pocetHradel == -1) {
        
                    i--;
                    hradloPrijato = false;
                    delete hr;
                } else {
                    //hradlo je ok.
                    hradloPrijato = true;
                    bitlevelpokriti = bitlevelpokriti | hr->getPokryti();
                    zastoupeniHradel[typHradlaint]++; // prictu hradlo
                    obv[level].push_back(hr);

                  
                }


            } else {
                //hradlo vede na tautologii zmenit
                hradloPrijato = false;
                i--;
                delete hr;

            }

        }


        delete genvst;
        cout << ".";
    }
    cout << endl;

    bool konec = false;
	int realnypocethradel;
    int nalezenoHradel;
    minNalezenoHradel = 1000000000;
    maxNalezenoHradel = -1;
  
	double mereniprumer=0;
	double merenpocet=0;
	//string nna=param->model+".logg";
	//ofstream stream("testovaniHeuristika.txt", ios::app);//pro vypis pri nenalezeni, na vypocet heur.dat
	//ofstream stream2(nna.c_str(), ios::out);//na vypis vsech poctu nalezenich veliksoti obvodu

	int start;
    if (param->pocetHradel != -1) {
        obv.push_back(a);
        //musim dodelat posledni uroven Heuristika v praxi
        for (int x = levels; x >= max(0, levels - param->hloubkaNavaznosti+1); x--) {//tadz max(1, le
            p1.first = levels;
            p2.first = x;
            for (unsigned int i = 0; i < obv[levels].size(); i++) { ////tady bylo  i < obv[levels -1].size()
                p1.second = i;
				if(x==levels){
					start=i+1;
				}else{
					start = 0;
				}
                for (unsigned int j =start; j < obv[x].size(); j++) { //tady bylo  j < obv[levels -1].size()
                    p2.second = j;
                    s.clear();
                    s.push_back(p1);
                    s.push_back(p2);
                    nalezenoHradel = getPocetHradel(&obv, &s);
 
					mereniprumer=mereniprumer+nalezenoHradel;
					merenpocet++;
                    //stream2<<nalezenoHradel<<endl;
              

                    minNalezenoHradel = min(minNalezenoHradel, nalezenoHradel);
                    maxNalezenoHradel = max(maxNalezenoHradel, nalezenoHradel);
					if ((nalezenoHradel == (param->pocetHradel - 1-getPocetHradelNavicNaVystupy(param)))
						&&( gbitjejedna(obv[p1.first][p1.second]->getPokryti() | obv[p2.first][p2.second]->getPokryti()))) {
                        

                        //vygenerovat hradlo dvouvstupove
                        hradlaCetnost.clear();
                        for (int i = 1; i < HTYPESIZE; i++) {
                            for (int j = 0; j < param->cetnost[i]; j++) {
                                hradlaCetnost.push_back(i);
                            }
                        }
                        typHradlaint = hradlaCetnost[rand() % hradlaCetnost.size()];
                        typHradla = static_cast<HType> (typHradlaint); //vygeneruji typ hradla						

                        hr = new Hradlo(level, typHradla); //vytvorim hradlo 2 vstupy
                        hr->pushiHradlo(obv[p1.first][p1.second]);
                        hr->pushiHradlo(obv[p2.first][p2.second]);
                        hr->setPokryti(obv[p1.first][p1.second]->getPokryti() | obv[p2.first][p2.second]->getPokryti());
                        hr->vypoctiRiditelnostCOP();

                        if (hr->getRiditelnostCOP() > minRiditelnost && hr->getRiditelnostCOP() < maxRiditelnost) {
                            zastoupeniHradel[typHradlaint]++; // prictu hradlo
                            obv[obv.size() - 1].push_back(hr);
							cout << "OK" << endl;
                            konec = true;
                            break;
                        }else{
							/****/
							for(int ff= HTYPESIZE-1; ff>0;ff--){
								if(param->cetnost[ff]<=0){continue;}
								 typHradla = static_cast<HType> (ff); //projdu vsechny ostatni hradla, jestli nesplni riditelnost
								 hr->setType(typHradla);
								 hr->vypoctiRiditelnostCOP();
								 if (hr->getRiditelnostCOP() > minRiditelnost && hr->getRiditelnostCOP() < maxRiditelnost) {
									zastoupeniHradel[typHradlaint]++; // prictu hradlo
									obv[obv.size() - 1].push_back(hr);
									cout << "OK" << endl;
									konec = true;
									break;
								 }

							}
							if(konec){break;}

							/****/
							delete hr;
							hr=NULL;
						}
                    }

                }
                if (konec) {
                    break;
                }
            }
            if (konec) {
                break;
            }
        }
        if (!konec) {
			mereniprumer=mereniprumer/merenpocet;
			//stream<<param->model<<";"<<param->pocetVstupu<<";"<<param->pocetVystupu<<";"<<param->hloubkaNavaznosti<<";"<<param->pocetUrovniObvodu<<";"<<param->maxPocetVstupuHradla<<";"<<param->pocetHradel<<";"<<pocetHradelNaUrovni<<";"<<mereniprumer<<";"<<minNalezenoHradel<<";"<<maxNalezenoHradel<<endl;
			cout << "Generate " << param->pocetHradel<< " nodes faild. Find between " << minNalezenoHradel+1+getPocetHradelNavicNaVystupy(param) << " - " << maxNalezenoHradel+1+getPocetHradelNavicNaVystupy(param) << " nodes." << endl;
			cout << "Or output is not dependent on all inputs."<<endl;
			//cout<< "Rozsah "<<minNalezenoHradel<<" - "<<maxNalezenoHradel<<endl;
			//stream.close();
			//stream2.close();
            for (unsigned int i = 0; i < obv.size(); i++) {
                for (unsigned int j = 0; j < obv[i].size(); j++) {
                    delete obv[i][j];
                }
            }
            return ;
        }

		//-----------------------------Dodelat vytupy------------------------------

        jesteVystupu = param->pocetVystupu - 1;

		vector<int> urovneHradelNaVystup;
		bool prvnizevstupu;
		vector<  Hradlo*> dosazitelnaMnozina, dosazitelnaMnozina2, dosazitelnaMnozinaZaloha;
		cout<<"Create outputs";
		//pojistka proti zacykleni, nikdy k nemu nedoslo, ale co kdyby.
		int pojistka= 200000000;
        if (jesteVystupu > 0) {
			
            //vygenerovat hradlo dvouvstupove
            hradlaCetnost.clear();
            for (int i = 1; i < HTYPESIZE; i++) {
                for (int j = 0; j < param->cetnost[i]; j++) {
                    hradlaCetnost.push_back(i);
				
                }
            }
			for(unsigned int vst = 1;vst<param->urovnedohromady.size();vst++){
				cout<<".";
				urovneHradelNaVystup=getUrovneHradelNaJedenVystup(vst,param);

				if(urovneHradelNaVystup.size()==0){ //protazeni vstupu na vystup
					Hradlo *hrp;
					hrp=obv[0][rand()%obv[0].size()];
					obv[obv.size()-1].push_back(new Hradlo(hrp));
					continue;
				}
				prvnizevstupu=true;

				//ulozim vsechny hradla
				for(unsigned int k=0; k<urovneHradelNaVystup.size();k++){
					konec=false;
					while(!konec){//prvni se navaze na dva signali z obvodu
						typHradlaint = hradlaCetnost[rand() % hradlaCetnost.size()];
						typHradla = static_cast<HType> (typHradlaint); //vygeneruji typ hradla	
						hr = new Hradlo(urovneHradelNaVystup[k], typHradla); //vytvorim hradlo	2 vstupy
						//prvni vstup z minule urovne
						getDosazitelnaMnozina(&obv,obv[obv.size()-1][0],&dosazitelnaMnozina,urovneHradelNaVystup[k],1);
						tmp=rand()%dosazitelnaMnozina.size();
							ihr=dosazitelnaMnozina[tmp];
						hr->pushiHradlo(ihr);
						hr->setPokryti(ihr->getPokryti());

						if(prvnizevstupu){
								
								//------------------------//

								//druhy uz dosazitelny
								getDosazitelnaMnozina(&obv,obv[obv.size()-1][0],&dosazitelnaMnozina,urovneHradelNaVystup[k],param->hloubkaNavaznosti);
								bool okok=false;
								while(!okok){
									tmp=rand()%dosazitelnaMnozina.size();
									ihr=dosazitelnaMnozina[tmp];
									if(hr->getihradlo()->at(0)==ihr){
										dosazitelnaMnozina.erase(dosazitelnaMnozina.begin()+tmp);
									}else{
										okok=true;
									}
								}
								
								hr->pushiHradlo(ihr);
								hr->setPokryti(hr->getPokryti() | ihr->getPokryti());
								
						
						}else{//prvni ze vstupu
								//------------------------//
								//druhy je vstup z minula
								hr->pushiHradlo(obv[urovneHradelNaVystup[k-1]][obv[urovneHradelNaVystup[k-1]].size()-1]);
								hr->setPokryti(hr->getPokryti() | ihr->getPokryti());
								
						}


						hr->vypoctiRiditelnostCOP();

						if (hr->getRiditelnostCOP() > minRiditelnost && hr->getRiditelnostCOP() < maxRiditelnost) {
							zastoupeniHradel[typHradlaint]++; // prictu hradlo
							obv[urovneHradelNaVystup[k]].push_back(hr);
							prvnizevstupu=false;
							konec=true;
						//------------------------//
						}else{
							for(int ff=HTYPESIZE-1 ; ff>0;ff--){
								if(param->cetnost[ff]<=0){continue;}
									typHradla = static_cast<HType> (ff); //projdu vsechny ostatni hradla, jestli nesplni riditelnost
									hr->setType(typHradla);

									hr->vypoctiRiditelnostCOP();
									if (hr->getRiditelnostCOP() > minRiditelnost && hr->getRiditelnostCOP() < maxRiditelnost) {
										zastoupeniHradel[typHradlaint]++; // prictu hradlo
										obv[urovneHradelNaVystup[k]].push_back(hr);
										prvnizevstupu=false;
							            konec=true;
										break;
									}

							}
							if(!konec){
								delete hr;
							}
						}//konec else

						pojistka--;
						if(pojistka<0){
							cout<<"Outputs not created."<<endl;
							for (unsigned int i = 0; i < obv.size(); i++) {
								for (unsigned int j = 0; j < obv[i].size(); j++) {
									delete obv[i][j];
								}
							}
							return ;
						}

					}//konec vhile


				}
			//pridam zastupne hradlo na vystup pokud je to treba
				if(urovneHradelNaVystup[urovneHradelNaVystup.size()-1]!=(int)obv.size()-1){
					obv[obv.size()-1].push_back(new Hradlo(obv[urovneHradelNaVystup[urovneHradelNaVystup.size()-1]][  obv[urovneHradelNaVystup[urovneHradelNaVystup.size()-1]].size()-1  ]));
				}
			}
		}
        levels++; //puvodni hodnota
		realnypocethradel=param->pocetHradel;
	}else{
		s.clear();
        p1.first = obv.size() - 1;
		for( unsigned int i=0; i<obv[obv.size() - 1].size();i++){
           p1.second = i;
		   s.push_back(p1);
		}
		realnypocethradel=getPocetHradel(&obv,&s);

	}

	cout<<"OK"<<endl;
    cout << "Done." << endl;
	

    pojmenovaniObvodu(realnypocethradel, levels, &obv);

    cout << "Set names is done." << endl;
	//a tady budu upravovat vetveni
	// udelam si nove obv kde bude jen to co pouziju
	  vector< vector< Hradlo*> > obvN; //to se nebude muset nicit hradla jsou ty, co jsou v OBV
	  for(unsigned int i=0; i<obv.size();i++){
		  obvN.push_back(a);
		  for(unsigned int j=0; j<obv[i].size();j++){
			  if(i==0||obv[i][j]->getoname()!=""||obv[i][j]->getLevel()==-1){
				  obv[i][j]->tmp=0;
				 obvN[i].push_back(obv[i][j]);
			  }
		   }
	  }



	  int maximalniVetveni=getMaxVetveni(&obvN);
	  double prumerVetveni=getPrumerVetveni(&obvN);
	  int maximalniVetveni2;
	  double prumerVetveni2;
	  bool snizuj=true;
	  cout<<"Max signals fanout: "<<maximalniVetveni<<" average: "<<prumerVetveni<<endl;
	  if(param->maxVetveni!=-1||param->prumerVetveni!=-1){
		  cout<<"Reduces fanout";
		  while(snizuj){
				  snizVetveni(&obvN,param,minRiditelnost,maxRiditelnost);
				  maximalniVetveni2=getMaxVetveni(&obvN);
				  prumerVetveni2=getPrumerVetveni(&obvN);
				 if((maximalniVetveni==maximalniVetveni2&&prumerVetveni<=prumerVetveni2)||(param->maxVetveni>=maximalniVetveni2&&param->prumerVetveni>=prumerVetveni2)){
					  snizuj=false;
				  }else{
					  maximalniVetveni=maximalniVetveni2;
					  prumerVetveni=prumerVetveni2;
				  }
				 cout<<".";

		  }
		  cout<<"OK"<<endl;
		  cout<<"Max signals fanout: "<<getMaxVetveni(&obvN)<<" average: "<<getPrumerVetveni(&obvN)<<endl;
	  }



	  
	  if(param->vypocetRekonvergence) {
		  
		  cout<<"Calculation reconvergence"<<endl;
		  getRekonvergence(&obvN,param);
	  }



    vypocetCOPPozorovatelnosti(&obvN);
    cout << "Calculation observability done." << endl;



		//prejmenuju vstupn9 signaly na latch
	for(unsigned int i=param->pocetVstupu-param->latch; i<obvN.at(0).size();i++){
		obvN.at(0).at(i)->setOName("p"+obvN.at(0).at(i)->getoname());
	}
	//a vystupni
	int uk=0;
	for(unsigned  int i=0; i<obvN.at(obvN.size()-1).size();i++){
			if(obvN.at(obvN.size()-1).at(i)->getLevel()==-1){//zastupne hradlo
				hr=obvN.at(obvN.size()-1).at(i)->getihradlo()->at(0);
			}else{
			    hr= obvN.at(obvN.size()-1).at(i);
			}

			if((param->urovneLatch.size()!=0)&&((int)param->urovneLatch.size()>uk)&&(param->urovneLatch[uk]==hr->getLevel())){
				uk++;
				hr->setOName("ppo"+hr->getoname());
			}else{
				hr->setOName("po"+hr->getoname());
			}

	}
	vysledky(&obvN,param);
	if (param->log) {
		try{
         obvinfo(&obvN, param, false);
		} catch (exception e) {
		 cout<<e.what()<<endl;

	}
        cout << "Save log: " << param->model << ".log" << endl;
    }

	ulozOBV(&obvN, param);

    for (unsigned int i = 0; i < obv.size(); i++) {
        for (unsigned int j = 0; j < obv[i].size(); j++) {
            delete obv[i][j];
        }
    }
	return;
}





