#ifndef __Gener_h__
#define __Gener_h__

class Gener
{
public:
	Gener();
//Vygeneruje obvod podle parametru
 void generovani(Vstup * param);
 //snizi rekonvergenci podle parametru
 void getRekonvergence(vector< vector< Hradlo*> > * obvN,Vstup * param);
 
 //prati pocet hradel podle typu;
 vector<int> getCetnostHradel(vector< vector< Hradlo*> > * obvN);
 //Vrati maxVstupHradla
 int getMaxVstupHradla(vector< vector< Hradlo*> > * obvN);
 //Vrati prumerne vetveni obvodu
 double getPrumerVetveni( vector< vector< Hradlo*> > * obvN );
 //Vrati maximalni vetveni
 int getMaxVetveni( vector< vector< Hradlo*> > * obvN );
 //Vrati vypocitanou navaznost
 int getNavaznost(vector< vector< Hradlo*> > * obvN );
 //Vypocte pozorovatelnost
 void vypocetCOPPozorovatelnosti(vector< vector< Hradlo*> > * obv);
 //vytvori soubor s vypisem vlastnosti obvodu
 void obvinfo(vector< vector< Hradlo*> > * obv, Vstup * param, bool nactenySoubor);
 //prevede Network na OBV
 //vector< vector< Hradlo*> > networkToObv(Network * net);
 //Ziska parametry z externiho souboru
 Vstup blifinfo(Blif * b, string soubor);
 //Prepocita riditelnost obvodu celeho
 void prepocitatRiditelnost(vector< vector< Hradlo*> > * uobv);
 //Ulozi parametry jako soubor
 void saveParam(Vstup * param, string soubor);
private:
 bool gbitjejedna(bitvector b);
 bool gbitjenula(bitvector b);

 //Vypise zhodnoceni na vystup
 void vysledky(vector< vector< Hradlo*> > * uobv, Vstup * param);
 //prepocita pokryti vstupu vsech hradel
 void prepocitatPokryti(vector< vector< Hradlo*> > * uobv);
 //Pokusi se snizit vetveni obvodu podle parametru
 void snizVetveni(vector< vector< Hradlo*> > * obvN, Vstup * param, double minRiditelnost, double maxRiditelnost);
 //Vrati mnozinu vetveni, sTMP jestli preskakovat ty hradla, ktera maji tmp==-1. Kvuli zmene vetveni.
 void getMnozVetveni(vector< vector< Hradlo*> > * obv, vector< vector< Hradlo*> > * obvvetveni, bool sTMP);
 //Jestli je riditelnost vystupu stale v parametrech
 bool riditelnostVystupuProjde(vector< vector< Hradlo*> > * obvN, double minRiditelnost, double maxRiditelnost);
 //Jestli vsechny vystupy spolecne pokryvaji vsechny vstupy
 bool pokrytiVystupuIsOne(vector< vector< Hradlo*> > * obvN);
 //vrati pocet urovni pridanych hradel, ze kterych budou vytvoreny vystupy
 int getMaxPocetPridanychUrovniKvuliVystupum(int pocetUrovni, int hloubkaNavaznosti);
 //Vrati pocet hradel, ktere budu potrebovat na dokonceni urciteho poctu vystupu, pri hledani obvodus urcitzm poctem hradel
 int getPocetHradelNavicNaVystupy(Vstup * param);
 //vrati sirku obv nastavene pomoci heuristiky, ktera je zalozena na namerene tabulce
 int nastaveniSirkyObvoduTABheur(Vstup * param);
 //vrati sirku obv nastavene pomoci heuristiky, ktera je zalozena vypoctu. Nepresne... jen jako zaloha
 int nastaveniSirkyObvodu(Vstup * param);
 //vrati mnnozinu hradel, ktera je dosazitelna z urcite urovne obvodu. Unikat je pro opakovane pouziti tmp, rychleji. Pro nove unikat -1
 void getDosazitelnaMnozina(vector< vector< Hradlo*> > * obv, Hradlo * h , vector<Hradlo*> * dosazitelnaMnozina, int aktualniUroven, int hloubkaNavaznosti);
 void rekDosazitelnaMnozina( Hradlo * h, int aktualniUroven, int hloubkaNavaznosti,  vector<Hradlo*> * dosazitelnaMnozina);
 //vyposita pocet hradel, ktere pod sebou maji vstupni signaly
 int getPocetHradel(vector< vector< Hradlo*> > * obv, vector<pair<int, int> > * signaly);
 void rekgetPocetHradel(Hradlo * hr, int * pocet, int unikat);

 //pri doplnovani vstupu potrebuji vedet kolik davam hradel na jeden vstup
 vector<int> getUrovneHradelNaJedenVystup(int cislovystupu ,Vstup * param);

 void ulozOBV(vector< vector< Hradlo*> > * obv, Vstup * param);
 //prevede OBV do Network
 Network * obvToNetwork(vector< vector< Hradlo*> > * obv);
 //vytvori Node pro prevod OBV do Network
 Node * generAND(bool neg, vector<string> * inames, string oname);
 Node * generOR(bool neg, vector<string> * inames, string oname);
 Node * generXOR(bool neg, vector<string> * inames, string oname);
 Node * generINV(string iname, string oname);

 //pomocna metoda na vypis
 string bitvectortostr(bitvector b);
 string typetostr(HType t);


 //pojmenuje a nastavi cely obvod oname, ohradlo, inames;
 void pojmenovaniObvodu( int pocethradel, int levels, vector< vector< Hradlo*> > * uobv);
 //rekurze na pojmenovani vsech hradel a nastaveni oname, ohradlo, inames
 void pojmenovaniSignalu(Hradlo *h, int * pocet, int velikost, int velikost2);
 //pojmenuje Hradlo
 string pojmenujHradlo(int * pocet, Hradlo * h, const int velikost, const int velikostl);
 //prevede int na string. Pouzito na pojmenovani signalu
 string inttostr(int const in, int const velikost);


};
#endif