#include "stdafx.h"

using namespace std;
#include "../../Kernel/kernelincludes.h"
#include "Hradlo.h"
#include "GenerVstupu.h"

bool GenerVstupu::bitjejedna(bitvector b){
	for(unsigned int i=0; i<b.size();i++){
		if(b[i]==0){
			return false;
		}
	}
	return true;
}
bool GenerVstupu::bitjenula(bitvector b){
	for(unsigned int i=0; i<b.size();i++){
		if(b[i]==1){
			return false;
		}
	}
	return true;
}

GenerVstupu::GenerVstupu(){
}

GenerVstupu::GenerVstupu( vector< vector< Hradlo * > > * obv,int novaUroven,int hloubkaNavaznosti){

	this->hloubkaNavaznosti=hloubkaNavaznosti;
	this->obv=obv;
	this->novaUroven=novaUroven;
	this->pokryti.clear();
	this->pokryti.resize(obv->at(0).at(0)->getPokryti().size(),false);
	for(unsigned int i=0;i<pokryti.size();i++){
		pokryti.setbit(i,false);
	}
	starepokryti=pokryti;

	pair<int,int> p;
	mnoz1 = new vector<pair<int,int> >();
	mnoz1bezinv = new vector<pair<int,int> >();
	mnoz2 = new vector<pair<int,int> >();
	for(int i=novaUroven-1;i>=max(0,novaUroven-hloubkaNavaznosti);i--){
		p.first=i;
		for(unsigned int j=0;j<obv->at(i).size();j++){
			p.second=j;
			mnoz2->push_back(p);
			if(i==novaUroven-1){
				
				mnoz1->push_back(p);
                if(p.first==0){//pro vstupy
                    mnoz1bezinv->push_back(p);
                }else{// pro vsechny ostatni urovne
                    if(obv->at(p.first).at(p.second)->getType()!=INV){
                            mnoz1bezinv->push_back(p);
                    }                                
                }

			}
		}
	}

	//cout<<"start L: "<<novaUroven<<" "<<bitvectortostr(pokryti)<<endl;

}


vector<pair<int,int> > * GenerVstupu::getSignal(int pocet,bool minulehradloprijato){
	vector<pair<int,int> > * vstupy=new vector<pair<int,int> >() ;
	vector<pair<int,int> > * zahozene=new vector<pair<int,int> >() ;

	
	pair<int,int> prvni,p;

	bitvector pokrytihradla;
	pokrytihradla.resize(obv->at(0).at(0)->getPokryti().size(),0);
	for(unsigned int i=0;i<pokrytihradla.size();i++){
		pokrytihradla.setbit(i,false);
	}
	//kdyz hradlo z minula nebylo prijato, nastaveni minule hodnoty pokryti
	if(minulehradloprijato){
		starepokryti=pokryti;
	}else{
		pokryti=starepokryti;
	}

	int uk;
	int pocetPokusu=0;
	//vygeneruji nahodne prvek z minule urovne ktery zvysi pokriti urovne
	//prvni vstup do hradla
	//---z minule urovne
	//---musi rozsirit pokryti urovne pokud jiz neni kompletne pokryto
	//-------pokud takovy vstup neexistuje je jedno jaky
	vector<pair<int,int> > *aktualprvnimnozina ;
	if(pocet==1&&mnoz1bezinv->size()!=0){
		aktualprvnimnozina=mnoz1bezinv;
	}else{
		aktualprvnimnozina=mnoz1;
	}
       
	uk=rand()%aktualprvnimnozina->size();

	prvni=aktualprvnimnozina->at(uk);
	if(!bitjejedna(pokryti)){
		while(!rozsiriPokriti(pokryti,obv->at(prvni.first).at(prvni.second)->getPokryti())){
			aktualprvnimnozina->erase(aktualprvnimnozina->begin()+uk);
			aktualprvnimnozina->push_back(prvni);
			pocetPokusu++;
			if((int)aktualprvnimnozina->size()==pocetPokusu){//zadna nerozsiri uroven. pouziji posledni zkousenou
				break;
			}
			
			
			uk=rand()%(aktualprvnimnozina->size()-pocetPokusu);
			prvni=aktualprvnimnozina->at(uk);
		}
	}

	
	pokryti=pokryti|obv->at(prvni.first).at(prvni.second)->getPokryti();//nove pokryti
	pokrytihradla=pokrytihradla|obv->at(prvni.first).at(prvni.second)->getPokryti();//nove pokryti
	

	pocetPokusu=0;
	bool bpokrytiUrovne =true;
	bool bpokrytiHradla = true;
	
	for(int i=1; i<pocet;i++){
		mnoz2->insert(mnoz2->end(),zahozene->begin(),zahozene->end());
		zahozene->clear();

		//pokusim se najit takovy vstup, ktery rozsiri pokryti urovne
		if(bpokrytiUrovne&&(!bitjejedna(pokryti))){
			uk=rand()%(mnoz2->size());
			p=mnoz2->at(uk);
																					
			while(!rozsiriPokriti(pokryti,obv->at(p.first).at(p.second)->getPokryti())||((p.first==prvni.first&&p.second==prvni.second))){

				mnoz2->erase(mnoz2->begin()+uk);
				zahozene->push_back(p);
				if(mnoz2->size()==0){
					uk=-1;
					break;
				}
				
				uk=rand()%(mnoz2->size());
				p=mnoz2->at(uk);
					
			}
			if(uk!=-1){//nalezen
				
				vstupy->push_back(p);
				mnoz2->erase(mnoz2->begin()+uk);

				if(mnoz2->size()==0){
					bpokrytiUrovne=false;
					mnoz2->insert(mnoz2->end(),zahozene->begin(),zahozene->end());
					zahozene->clear();
				}
				pokryti=pokryti|obv->at(p.first).at(p.second)->getPokryti();//nove pokryti
				pokrytihradla=pokrytihradla|obv->at(p.first).at(p.second)->getPokryti();
				continue;
			}else{//nenalezen neexistuje (asi obvod uz nepujde slozit)
		
				if(mnoz2->size()==0){
					bpokrytiUrovne=false;
					mnoz2->insert(mnoz2->end(),zahozene->begin(),zahozene->end());
					zahozene->clear();
					
				}
			}
		}

		//zadny dalsi vstup nerozsiri pokryti nebo to neni potreba
		//hledam vstup ktery rozsiri pokryti hradla
		if(bpokrytiHradla&&!bitjejedna(pokrytihradla)){
			uk=rand()%(mnoz2->size());
			p=mnoz2->at(uk);
			while((!rozsiriPokriti(pokrytihradla,obv->at(p.first).at(p.second)->getPokryti()))||((p.first==prvni.first&&p.second==prvni.second))){

				mnoz2->erase(mnoz2->begin()+uk);
				zahozene->push_back(p);
				if(mnoz2->size()==(0)){
					uk=-1;
					break;
				}
				
				uk=rand()%(mnoz2->size());
				p=mnoz2->at(uk);
			}
			if(uk!=-1){//nalezen
				
				vstupy->push_back(p);
				mnoz2->erase(mnoz2->begin()+uk);
				if(mnoz2->size()==0){
					bpokrytiHradla=false;
					mnoz2->insert(mnoz2->end(),zahozene->begin(),zahozene->end());
					zahozene->clear();
				}
				pokryti=pokryti|obv->at(p.first).at(p.second)->getPokryti();//nove pokryti
				pokrytihradla=pokrytihradla|obv->at(p.first).at(p.second)->getPokryti();
				continue;
			}else{//nenalezen neexistuje (asi obvod uz nepujde slozit)
				if(mnoz2->size()==0){
					bpokrytiHradla=false;
					mnoz2->insert(mnoz2->end(),zahozene->begin(),zahozene->end());
					zahozene->clear();
				}

			}
			
		}
		//tady je to jedno
		
		uk=rand()%(mnoz2->size());
		p=mnoz2->at(uk);
		while((p.first==prvni.first&&p.second==prvni.second)){
			mnoz2->erase(mnoz2->begin()+uk);
			zahozene->push_back(p);
			uk=rand()%(mnoz2->size());
			p=mnoz2->at(uk);
		}

		vstupy->push_back(p);
		mnoz2->erase(mnoz2->begin()+uk);
		if(mnoz2->size()==0){
			mnoz2->insert(mnoz2->end(),zahozene->begin(),zahozene->end());
			zahozene->clear();
		}


		pokryti=pokryti|obv->at(p.first).at(p.second)->getPokryti();//pokryti urovne
		pokrytihradla=pokrytihradla|obv->at(p.first).at(p.second)->getPokryti();//nove pokryti hradle

	}



	mnoz2->insert(mnoz2->end(),zahozene->begin(),zahozene->end());
	mnoz2->insert(mnoz2->end(),vstupy->begin(),vstupy->end());
	vstupy->push_back(prvni);
	delete zahozene;
	zahozene=NULL;


	return vstupy;
	
}


bool GenerVstupu::rozsiriPokriti(bitvector puvodni, bitvector novy){
	bitvector b= (puvodni|novy)^puvodni;
	return !bitjenula(b);
}
GenerVstupu::~GenerVstupu(){
	delete mnoz1;
	delete mnoz2;
	delete mnoz1bezinv;
}

string  GenerVstupu::bitvectortostr(bitvector b){
	  string s="";
	  for(unsigned int i=0; i<b.size();i++){
		  if(b[i])s=s+"1";
		  else s=s+"0";
	  }
	  return s;
  }
