#include "stdafx.h"


using namespace std;


#include "../../Kernel/kernelincludes.h"
#include "../../Multilevel/Blif.h"
#include "../../Multilevel/Node.h"
#include "../../Multilevel/Signal.h"
#include "../../Multilevel/Network.h"
#include <stdexcept>
#include "Hradlo.h"
#include "Vstup.h"
#include "Gener.h"

int main(int argc, char* argv[]) {
	Gener g;
    Vstup * parametry;
	cout<<"Parametrized Generator of Logic Circuits"<<endl;
	if(argc==1||argc>4){
		cout<<"Bad parameters"<<endl;
	}
	if(argc==3||argc==4){
		//prvni -info
		//druhy soubor
		//treti nazev souboru s parametry

		Blif bb;
		try{
			bb.LoadBlif(argv[2]);
		}catch (IOException e) {
			cout<<e.GetMsg()<<endl;
			return 0;
		}
		
		Vstup param;
		vector< vector <Hradlo * > > obv;
		try{
		   param=  g.blifinfo(&bb,argv[2]);
		  } catch (exception e) {
			cout << e.what() << endl;
			return 0;
        }
		string nazev="param";
		string p="";
		if(argc==4){
			nazev=argv[3];
		}else{
			nazev="param.txt";
		}
		g.saveParam(&param,nazev);
		return 0;

	}

	if(argc==2){
		string ar=argv[1];
		if(ar=="?"){
			cout<<"Karel Houzvicka 2012"<<endl;
			cout<<endl;
			cout<<"Info:"<<endl;
			cout<<"Gener -info circuit.blif [param.txt]"<<endl;
			cout<<"Creates a text file with circuit parameters. The text file is in the format for circuit generation. Default name is param.txt ."<<endl;
			cout<<"The file circuit.blif must be remaped with ABC."<<endl;
			cout<<endl;
			cout<<"Generate:"<<endl;
			cout<<"Gener param.txt"<<endl;
			cout<<"Creates a circuit by parameters from the file."<<endl;
			return 0;
		}



		try {
			parametry = new Vstup(argc, argv);
		} catch (exception e) {
			cout << e.what() << endl;
			return 0;
		}

		cout << "Inputs: " << parametry->pocetVstupu-parametry->latch << endl;
		cout << "Outputs: " << parametry->pocetVystupu-parametry->latch << endl;
		cout << "Level output: ";
		for(unsigned  int i=0; i<parametry->urovneVystupu.size();i++){
			cout<<parametry->urovneVystupu[i]<<" ";
		}
		cout<<endl;
		cout<<"Latchs: "<<parametry->latch<<endl;
		if(parametry->latch>0){
			cout << "Level latch: ";
			for(unsigned  int i=0; i<parametry->urovneLatch.size();i++){
				cout<<parametry->urovneLatch[i]<<" ";
			}
			cout<<endl;
		}
		cout << "Levels: " << parametry->pocetUrovniObvodu << endl;
		cout << "Max inputs node: " << parametry->maxPocetVstupuHradla << endl;
		if (parametry->pocetHradel != -1) {
			cout << "Nodes: " << parametry->pocetHradel << endl;
		}
		cout << "Max lenght signals: " << parametry->hloubkaNavaznosti << endl;
		if(parametry->maxVetveni!=-1){
			 cout<< "Max signal fanout: "<<parametry->maxVetveni<<endl;
		}
		if(parametry->prumerVetveni!=-1){
			cout<< "Average signal fanout: "<<parametry->prumerVetveni<<endl;
		}

		cout << "Model name: " << parametry->model<<".blif" << endl;

		g.generovani(parametry);

		delete parametry;
		return 0;
	}
}
