#ifndef __Hradlo_h__
#define __Hradlo_h__

class RekonBunkaSeznam;
class RekonObj;

#define  HTYPESIZE 7

typedef enum HType  {INV, XOR, NXOR, AND, OR, NAND, NOR} HType;


class Hradlo
{
private:
	int level;
	HType typ;
	int icount; //pocet vstupu
	string oname; //jmeno, vystupni jmeno signalu
	vector<Hradlo * > * ihradlo; //mnozina ukazatelu na hradla vstupnich signalu
	vector<string > * inames; //vzdy se vypocitanova znova
	int iport; //sem bude navayan vstup v levelu 0
	vector<Hradlo * > * ohradlo; // mnozina hradel, kam je pripojen vystupni signal
	bitvector  pokryti; //ukaze pokrtiti vstupnich promennych.
	double riditelnostCOP; // riditelnost
	vector<double> * pozorCOPVstupu;
	double pozorCOPVystupu;
	RekonBunkaSeznam * rekonverg;
	list<RekonObj *> * nalezeneRekonvergence;
public:
	int tmp;
	int tmpdosazitelnaMnozina;
	Hradlo();
	Hradlo( int level, HType typ);// pro uroven >=1
	Hradlo(int iport); //pro navazani vstupu a nastaveni rekonvergence
	Hradlo(Hradlo*); //pro vyvedeni vystupu znameni level -1;

	void vypoctiRekonvergenci(int pocetvstupu, int poceturovni);
	list<RekonObj *> * getRekonvergence();
	void getRokonvergenceVector(vector < vector <RekonObj *> > * v);
	void setOName(string);
	void setType(HType);
	void setPokryti(bitvector );
	void setLevel(int);
	
	int getLevel();
	HType getType();
	double getRiditelnostCOP();
	bitvector  getPokryti();
	void pushiHradlo(Hradlo*);
	void eraseihradlo(unsigned int index);
	void eraseihradlo(Hradlo * h);
	void eraseohradlo(unsigned int index);
	void eraseohradlo(Hradlo * h);
	void pushoHradlo(Hradlo*);
	int geticount();
	int getiport();
	vector<Hradlo *> * getihradlo();
	string getoname();
	vector<Hradlo * > * getohradlo();

	vector<string>* getinames();
	double getPozorovatelnostCOPVystupu();
	double getPozorovatelnostCOPVstupu(int);
	void vypoctiPozorovatelnostCOP();
	void vypoctiRiditelnostCOP();
	bool existujeJinyVstupZMinuleUrovneNez(int indexihradla);
	bool existujeJinyVstupZMinuleUrovneNez(Hradlo * ihr);
	bool jeDuplicitniVstup(Hradlo*);
	int getiindex(string); //vrati index vstupniho jmena. pro najiti spravneho ihradla
	int getiindex(Hradlo *);
	
	~Hradlo(void);
};
#endif