//---------------------------------------------------------------------------

#include "stdafx.h"

using namespace std;

#ifdef _MSC_VER
#pragma hdrstop
#endif

#include "utils.h"
#include "ctype.h"

//---------------------------------------------------------------------------

// PLA Parser

void GetLine( ifstream &f, char *line )
{
	f.getline(line, MAXLINE);
	if ( line[strlen(line)-1] == 13 ) line[strlen(line)-1] = 0;		// for Linux
	while ( line[strlen(line)-1] == '\\' ) {
		f.getline(&line[strlen(line)-1], MAXLINE);
		if ( line[strlen(line)-1] == 13 ) line[strlen(line)-1] = 0;		// for Linux
	}
}

string GetToken( const char *line, unsigned int &pos )
{
    string s;

    while ( line[pos] == ' ' || line[pos] == '|' || line[pos] == 10 || line[pos] == 9 || line[pos] == 13 ) pos++;
    while ( line[pos] != ' ' && line[pos] != '|' && line[pos] != 0 && line[pos] != 10 && line[pos] != 9 && line[pos] != 13 )
        s+=line[pos++];
    return s;
}

string RemoveSpaces( const string &s )
{
	unsigned int i, j;

	for ( i = 0; i < s.length(); i++ )
		if ( s[i] != ' ' && s[i] != 10 && s[i] != 13 && s[i] != 9 ) break;
	for ( j = s.length()-1; j >= i; j-- ) {
		if ( s[j] != ' ' && s[j] != 10 && s[j] != 13 && s[j] != 9 ) break;
	}
	return s.substr(i, j-i+1);
}

string GetExtension( const string &s )
// returns the filename extension
{
	string res;
	unsigned int i;

	i = s.find_last_of( "." );
	res = s.substr(i+1, s.length() );
	return res;
}

string GetFilename( const string &s )
// returns the filename from the complete path
{
	basic_string <char>::size_type j;
	string res;
	static const basic_string <char>::size_type npos = -1;

	j = s.rfind(".", s.size()-1);
	if ( j != npos ) res = s.substr(0, s.rfind(".", s.size()-1));
	else res = s;
	j = res.rfind("\\", res.size()-1);
	if ( j == npos ) j = res.rfind("/", res.size()-1);
	else if ( j == npos ) j = -1;
	j++;
	res = res.substr(j, res.size()-j);
	return res;
}

string int2bin( unsigned int num, unsigned int length )
{
    string res;
    int pos = 1;
	unsigned int i;

    for( i = 0; i < length; i++ ) {
        res = (num & pos) ? "1" + res : "0" + res;
		pos <<= 1;
    }
    return res;
}

string int2string( unsigned int num )
{
	char s[1000];

	sprintf(s, "%i", num);
	return string(s);
}

bool existsFile( string fn )
{
	ifstream f;

	f.open(fn.c_str());
	if ( f.is_open() ) {
		f.close();
		return true;
	} else return false;
}

void to_upper(std::string& s)
{
	string::iterator si;

	for ( si = s.begin(); si != s.end(); ++si )
    *si = toupper((unsigned char)*si);
}
